<?php

namespace OrganizationsManagement\Controller;

use Exception;
use OrganizationsManagement\Traits\TResponse;
use Zeedhi\Framework\DTO;
use OrganizationsManagement\Service\CollectionErrors as CollectionErrorsService;

class CollectionErrors
{

    use TResponse;

    /**
     * @var CollectionErrorsService
     */
    private $collectionErrorsService;

    /**
     * @param CollectionErrorsService
     */
    public function __construct(CollectionErrorsService $collectionErrorsService)
    {
        $this->collectionErrorsService = $collectionErrorsService;
    }

    public function find(DTO\Request $request, DTO\Response $response)
    {
        try {
            $data = $this->collectionErrorsService->find();
            $this->sendResponse($data, 200);
        } catch (Exception $ex) {
            $this->sendResponse(['error' => $ex->getMessage(), 'code' => $ex->getCode()], 500);
        }
    }
}
