<?php

namespace OrganizationsManagement\Repository;

use OrganizationsManagement\Util\InstanceProvider;
use OrganizationsManagement\Util\Utilities;
use Teknisa\Model\Traits\TQuery;




class OmParcnegocio
{
    use TQuery;

    public function getItensContrato($nrfaturacont, $nrorg, $nrparcnegocio, $filter){
        $query = <<<SQL
            SELECT TO_CHAR(ITCONT.NRITEMOCONTRATO) AS IDARVORE,
                   NULL AS IDARVOREPAI,
                   CONT.NRSEQCONTRATO,
                   CONT.NRCONTRATOFCT,
                   ITFAT.NRFATURACONT,
                   ITFAT.NRITFATURACONT,
                   ITFAT.VRVENCIMENTO AS VRSEMDESCONTO,
                   ITFAT.VRVENCIMENTO AS VRVENCIMENTO,
                   NULL AS VRPERCDESCITEM,
                   NULL AS VRDESCITEM,
                   DECODE(REL.IDPARCAGRUP, 'S', DECODE(ITCONT.NRITEMCONTRATOPAI, NULL, ITCONT.NMITEMCONTRATO || ' (' || CONT.NRCONTRATOFCT || ')', ITCONT.NMITEMCONTRATO), ITCONT.NMITEMCONTRATO) AS NMITEMCONTRATO,
                   ITFAT.IDFORMAFATURA,
                   FAT.IDALTUSUARIO,
                   FAT.DSJUSTIFICATIVA
              FROM FCT_ITFATURACONT ITFAT
             INNER JOIN FCT_FATURACONT FAT
                ON ITFAT.NRFATURACONT = FAT.NRFATURACONT
             INNER JOIN FCT_RELACAGRUPCONTFAT REL
                ON FAT.NRFATURACONT = REL.NRFATURACONT
             INNER JOIN FCT_CONTRATO CONT
                ON REL.NRSEQCONTRATO = CONT.NRSEQCONTRATO
             INNER JOIN FCT_ITEMCONTRATO ITCONT
                ON REL.NRSEQCONTRATO      = ITCONT.NRSEQCONTRATO
               AND ITFAT.NRITEMOCONTRATO = ITCONT.NRITEMOCONTRATO
             INNER JOIN FCT_ITNEGOCIACAOCONTRATO ITNEG
                ON ITCONT.NRITEMOCONTRATO = ITNEG.NRITEMOCONTRATO
             INNER JOIN FCT_NEGOCIACAOCONTRATO NEG
                ON ITNEG.NRNEGOCIACAOCONTRATO = NEG.NRNEGOCIACAOCONTRATO
               AND CONT.NRSEQCONTRATO         = NEG.NRSEQCONTRATO
             WHERE 'P' || FAT.NRFATURACONT = :NRFATURACONT
               AND REL.NRMEDICAOFATURA IS NULL
               AND FAT.NRMEDICAOFATURA IS NULL
             UNION ALL
            SELECT IDARVORE,
                   IDARVOREPAI,
                   NRSEQCONTRATO,
                   NRCONTRATOFCT,
                   NRFATURACONT,
                   NRITFATURACONT,
                   CASE WHEN (NRMEDICAOFATURAAUX IS NOT NULL AND IDSITUACAO = 1) THEN
                       DECODE(IDARVOREPAI, NULL, VRTOTITEMCONTEST, DECODE(IDMULTIPVARIACAOEST, 'S', VRUNITARIOEST * QTMEDIDAMEDICAOEST, VRUNITARIOEST * QTMEDIDACONTR))
                   ELSE
                       VRSEMDESCONTO
                   END AS VRSEMDESCONTO,
                   CASE WHEN (NRMEDICAOFATURAAUX IS NOT NULL AND IDSITUACAO = 1) THEN
                       DECODE(IDARVOREPAI, NULL, DECODE(IDMULTIPVARIACAOEST, 'S', VRUNITARIOEST * QTMEDIDAMEDICAOEST, VRUNITARIOEST * QTMEDIDACONTR), NULL)
                   ELSE
                       VRVENCIMENTO
                   END AS VRVENCIMENTO,
                   DECODE(NRMEDICAOFATURAAUX, NULL, VRPERCDESCITEM, DECODE(IDSITUACAO, 1, VRPERCDESCITEMEST, VRPERCDESCITEM)) AS VRPERCDESCITEM,
                   DECODE(NRMEDICAOFATURAAUX, NULL, VRDESCITEM, DECODE(IDSITUACAO, 1, VRDESCITEMEST, VRDESCITEM)) AS VRDESCITEM,
                   NMITEMCONTRATO,
                   IDFORMAFATURA,
                   IDALTUSUARIO,
                   DSJUSTIFICATIVA
              FROM (
                SELECT IDARVORE,
                       IDARVOREPAI,
                       NRSEQCONTRATO,
                       NRCONTRATOFCT,
                       IDSITUACAO,
                       NRFATURACONT,
                       NRITFATURACONT,
                       VRUNITARIO,
                       VRUNITARIOEST,
                       DECODE(IDARVOREPAI, NULL, VRTOTITEMCONT, DECODE(IDMULTIPVARIACAO, 'S', VRUNITARIO * QTMEDIDAMEDICAO, VRUNITARIO * QTMEDIDACONTR)) AS VRSEMDESCONTO,
                       DECODE(IDARVOREPAI, NULL, DECODE(IDMULTIPVARIACAO, 'S', VRUNITARIO * QTMEDIDAMEDICAO, VRUNITARIO * QTMEDIDACONTR), NULL) AS VRVENCIMENTO,
                       DECODE(IDARVOREPAI, NULL, DECODE(VRTOTITEMCONT, 0, 0, (VRDESCITEM * 100) / VRTOTITEMCONT), NULL)  AS VRPERCDESCITEM,
                       DECODE(IDARVOREPAI, NULL, DECODE(VRTOTITEMCONTEST, 0, 0, (VRDESCITEMEST * 100) / VRTOTITEMCONTEST), NULL)  AS VRPERCDESCITEMEST,
                       DECODE(IDARVOREPAI, NULL, VRDESCITEM, NULL) AS VRDESCITEM,
                       DECODE(IDARVOREPAI, NULL, VRDESCITEMEST, NULL) AS VRDESCITEMEST,
                       NMITEMCONTRATO,
                       IDFORMAFATURA,
                       IDALTUSUARIO,
                       DSJUSTIFICATIVA,
                       NRMEDICAOFATURAAUX,
                       VRTOTITEMCONT,
                       QTMEDIDACONTR,
                       VRTOTITEMCONTEST,
                       IDMULTIPVARIACAOEST,
                       QTMEDIDAMEDICAOEST
                  FROM (
                    SELECT TO_CHAR(ITCONT.NRITEMOCONTRATO) AS IDARVORE,
                           TO_CHAR(ITCONT.NRITEMCONTRATOPAI) AS IDARVOREPAI,
                           CONT.NRSEQCONTRATO,
                           CONT.NRCONTRATOFCT,
                           MED.IDSITUACAO,
                           ITMED.NRMEDICAOFATURA AS NRFATURACONT,
                           ITMED.NRITMEDICAOFATURA AS NRITFATURACONT,
                           DECODE(MEDVAR.NRMEDVARMEDICAOFATURA, NULL, ITMED.VRITEMCONT, DECODE(MEDVAR.QTMEDIDAMEDICAO, 0, 0, DECODE(NVL(VAR.VRPRECOVARIACAO, 0), 0, ITCONT.VRUNITITEMCONT, DECODE(NVL(VARVEND.VRPRECOVARIACAO, 0), 0, ITCONT.VRUNITITEMCONT, ITCONT.VRUNITITEMCONT / VARVEND.VRPRECOVARIACAO * VAR.VRPRECOVARIACAO)))) AS VRUNITARIO,
                           DECODE(MEDVAREST.NRMEDVARMEDICAOFATURA, NULL, ITMEDEST.VRITEMCONT, DECODE(MEDVAREST.QTMEDIDAMEDICAO, 0, 0, DECODE(NVL(VAREST.VRPRECOVARIACAO, 0), 0, ITCONT.VRUNITITEMCONT, DECODE(NVL(VARVEND.VRPRECOVARIACAO, 0), 0, ITCONT.VRUNITITEMCONT, ITCONT.VRUNITITEMCONT / VARVEND.VRPRECOVARIACAO * VAREST.VRPRECOVARIACAO)))) AS VRUNITARIOEST,
                           ITCONT.NMITEMCONTRATO,
                           NULL AS IDFORMAFATURA,
                           NULL AS IDALTUSUARIO,
                           NULL AS DSJUSTIFICATIVA,
                           ITCONT.QTMEDIDACONTR,
                           ITMED.VRTOTITEMCONT,
                           NVL(ITMED.VRTOTITEMCONT, 0) - NVL(ITMED.VRITEMCONT, 0) AS VRDESCITEM,
                           MEDVAR.IDMULTIPVARIACAO,
                           MEDVAR.QTMEDIDAMEDICAO,
                           EST.NRMEDICAOFATURAAUX,
                           ITMEDEST.VRTOTITEMCONT AS VRTOTITEMCONTEST,
                           NVL(ITMEDEST.VRTOTITEMCONT, 0) - NVL(ITMEDEST.VRITEMCONT, 0) AS VRDESCITEMEST,
                           MEDVAREST.IDMULTIPVARIACAO AS IDMULTIPVARIACAOEST,
                           MEDVAREST.QTMEDIDAMEDICAO AS QTMEDIDAMEDICAOEST
                      FROM FCT_ITMEDICAOFATURA ITMED
                     INNER JOIN FCT_MEDICAOFATURA MED
                        ON ITMED.NRMEDICAOFATURA = MED.NRMEDICAOFATURA
                     INNER JOIN FCT_RELACAGRUPCONTFAT REL
                        ON MED.NRMEDICAOFATURA = REL.NRMEDICAOFATURA
                       AND MED.NRSEQCONTRATO   = REL.NRSEQCONTRATO
                     INNER JOIN FCT_CONTRATO CONT
                        ON MED.NRSEQCONTRATO = CONT.NRSEQCONTRATO
                     INNER JOIN FCT_ITEMCONTRATO ITCONT
                        ON MED.NRSEQCONTRATO = ITCONT.NRSEQCONTRATO
                       AND ITMED.CDSERVORCA  = ITCONT.CDSERVORCA
                     INNER JOIN FCT_ITNEGOCIACAOCONTRATO ITNEG
                        ON ITCONT.NRITEMOCONTRATO = ITNEG.NRITEMOCONTRATO
                     INNER JOIN FCT_NEGOCIACAOCONTRATO NEG
                        ON ITNEG.NRNEGOCIACAOCONTRATO = NEG.NRNEGOCIACAOCONTRATO
                      LEFT JOIN FCT_MEDVARMEDICAOFATURA MEDVAR
                        ON MED.NRMEDICAOFATURA = MEDVAR.NRMEDICAOFATURA
                       AND ITCONT.CDSERVORCA   = MEDVAR.CDSERVORCA
                       AND ITCONT.IDELEMENTO   = MEDVAR.IDELEMENTORAIZ
                      LEFT JOIN FCT_VARPRECBASESERVCONT VAR
                        ON MED.NRSEQCONTRATO         = VAR.NRSEQCONTRATO
                       AND ITCONT.CDTPMEDIDASERV     = VAR.CDTPMEDIDASERV
                       AND ITCONT.CDTPMEDIDAVARIAVEL = VAR.CDTPMEDIDAVARIAVEL
                       AND MED.NRORG                 = VAR.NRORG
                       AND MEDVAR.CDSERVORCA         = VAR.CDSERVORCA
                       AND (MEDVAR.QTMEDIDAMEDICAO + MEDVAR.QTFRANQUIA) BETWEEN VAR.QTMEDIDAINIVARIACAO AND VAR.QTMEDIDAFIMVARIACAO
                      LEFT JOIN FCT_VARPRECBASESERVCONT VARVEND
                        ON MED.NRSEQCONTRATO         = VARVEND.NRSEQCONTRATO
                       AND ITCONT.CDTPMEDIDASERV     = VARVEND.CDTPMEDIDASERV
                       AND ITCONT.CDTPMEDIDAVARIAVEL = VARVEND.CDTPMEDIDAVARIAVEL
                       AND MED.NRORG                 = VARVEND.NRORG
                       AND MEDVAR.CDSERVORCA         = VARVEND.CDSERVORCA
                       AND DECODE(NVL(MEDVAR.QTMEDIDAVENDIDA, 0), 0, 1, MEDVAR.QTMEDIDAVENDIDA) BETWEEN VARVEND.QTMEDIDAINIVARIACAO AND VARVEND.QTMEDIDAFIMVARIACAO
                      LEFT JOIN (TABLE(FCT_BUSCA_PRECOMEDICAO(:NRPARCNEGOCIO, :NRORG))) EST
                        ON MED.NRMEDICAOFATURA = EST.NRMEDICAOFATURA
                      LEFT JOIN FCT_ITMEDICAOFATURA ITMEDEST
                        ON EST.NRMEDICAOFATURAAUX = ITMEDEST.NRMEDICAOFATURA
                       AND ITMED.NRITEMOCONTRATO  = ITMEDEST.NRITEMOCONTRATO
                      LEFT JOIN FCT_MEDVARMEDICAOFATURA MEDVAREST
                        ON EST.NRMEDICAOFATURAAUX    = MEDVAREST.NRMEDICAOFATURA
                       AND MEDVAR.CDSERVORCA         = MEDVAREST.CDSERVORCA
                       AND MEDVAR.IDELEMENTORAIZ     = MEDVAREST.IDELEMENTORAIZ
                       AND MEDVAR.CDTPMEDIDAVARIAVEL = MEDVAREST.CDTPMEDIDAVARIAVEL
                      LEFT JOIN FCT_VARPRECBASESERVCONT VAREST
                        ON MED.NRSEQCONTRATO         = VAREST.NRSEQCONTRATO
                       AND ITCONT.CDTPMEDIDASERV     = VAREST.CDTPMEDIDASERV
                       AND ITCONT.CDTPMEDIDAVARIAVEL = VAREST.CDTPMEDIDAVARIAVEL
                       AND MED.NRORG                 = VAREST.NRORG
                       AND MEDVAREST.CDSERVORCA      = VAREST.CDSERVORCA
                       AND (MEDVAREST.QTMEDIDAMEDICAO + MEDVAREST.QTFRANQUIA) BETWEEN VAREST.QTMEDIDAINIVARIACAO AND VAREST.QTMEDIDAFIMVARIACAO
                     WHERE 'A' || REL.NRFATURACONT = :NRFATURACONT
                )
                ORDER BY IDARVORE
            )
            UNION ALL
            SELECT IDARVORE,
                   IDARVOREPAI,
                   NRSEQCONTRATO,
                   NRCONTRATOFCT,
                   NRFATURACONT,
                   NRITFATURACONT,
                   CASE WHEN (NRMEDICAOFATURAAUX IS NOT NULL AND IDSITUACAO = 1) THEN
                       DECODE(IDARVOREPAI, NULL, VRTOTITEMCONTEST, DECODE(IDMULTIPVARIACAOEST, 'S', VRUNITARIOEST * QTMEDIDAMEDICAOEST, VRUNITARIOEST * QTMEDIDACONTR))
                   ELSE
                       VRSEMDESCONTO
                   END AS VRSEMDESCONTO,
                   CASE WHEN (NRMEDICAOFATURAAUX IS NOT NULL AND IDSITUACAO = 1) THEN
                       DECODE(IDARVOREPAI, NULL, DECODE(IDMULTIPVARIACAOEST, 'S', VRUNITARIOEST * QTMEDIDAMEDICAOEST, VRUNITARIOEST * QTMEDIDACONTR), NULL)
                   ELSE
                       VRVENCIMENTO
                   END AS VRVENCIMENTO,
                   DECODE(NRMEDICAOFATURAAUX, NULL, VRPERCDESCITEM, DECODE(IDSITUACAO, 1, VRPERCDESCITEMEST, VRPERCDESCITEM)) AS VRPERCDESCITEM,
                   DECODE(NRMEDICAOFATURAAUX, NULL, VRDESCITEM, DECODE(IDSITUACAO, 1, VRDESCITEMEST, VRDESCITEM)) AS VRDESCITEM,
                   NMITEMCONTRATO,
                   IDFORMAFATURA,
                   IDALTUSUARIO,
                   DSJUSTIFICATIVA
              FROM (
                SELECT IDARVORE,
                       IDARVOREPAI,
                       NRSEQCONTRATO,
                       NRCONTRATOFCT,
                       IDSITUACAO,
                       NRFATURACONT,
                       NRITFATURACONT,
                       VRUNITARIO,
                       VRUNITARIOEST,
                       DECODE(IDARVOREPAI, NULL, VRTOTITEMCONT, DECODE(IDMULTIPVARIACAO, 'S', VRUNITARIO * QTMEDIDAMEDICAO, VRUNITARIO * QTMEDIDACONTR)) AS VRSEMDESCONTO,
                       DECODE(IDARVOREPAI, NULL, DECODE(IDMULTIPVARIACAO, 'S', VRUNITARIO * QTMEDIDAMEDICAO, VRUNITARIO * QTMEDIDACONTR), NULL) AS VRVENCIMENTO,
                       DECODE(IDARVOREPAI, NULL, DECODE(VRTOTITEMCONT, 0, 0, (VRDESCITEM * 100) / VRTOTITEMCONT), NULL)  AS VRPERCDESCITEM,
                       DECODE(IDARVOREPAI, NULL, DECODE(VRTOTITEMCONTEST, 0, 0, (VRDESCITEMEST * 100) / VRTOTITEMCONTEST), NULL)  AS VRPERCDESCITEMEST,
                       DECODE(IDARVOREPAI, NULL, VRDESCITEM, NULL) AS VRDESCITEM,
                       DECODE(IDARVOREPAI, NULL, VRDESCITEMEST, NULL) AS VRDESCITEMEST,
                       NMITEMCONTRATO,
                       IDFORMAFATURA,
                       IDALTUSUARIO,
                       DSJUSTIFICATIVA,
                       NRMEDICAOFATURAAUX,
                       VRTOTITEMCONT,
                       QTMEDIDACONTR,
                       VRTOTITEMCONTEST,
                       IDMULTIPVARIACAOEST,
                       QTMEDIDAMEDICAOEST
                  FROM (
                    SELECT TO_CHAR(ITCONT.NRITEMOCONTRATO) AS IDARVORE,
                           TO_CHAR(ITCONT.NRITEMCONTRATOPAI) AS IDARVOREPAI,
                           CONT.NRSEQCONTRATO,
                           CONT.NRCONTRATOFCT,
                           MED.IDSITUACAO,
                           ITMED.NRMEDICAOFATURA AS NRFATURACONT,
                           ITMED.NRITMEDICAOFATURA AS NRITFATURACONT,
                           DECODE(MEDVAR.NRMEDVARMEDICAOFATURA, NULL, ITMED.VRITEMCONT, DECODE(MEDVAR.QTMEDIDAMEDICAO, 0, 0, DECODE(NVL(VAR.VRPRECOVARIACAO, 0), 0, ITCONT.VRUNITITEMCONT, DECODE(NVL(VARVEND.VRPRECOVARIACAO, 0), 0, ITCONT.VRUNITITEMCONT, ITCONT.VRUNITITEMCONT / VARVEND.VRPRECOVARIACAO * VAR.VRPRECOVARIACAO)))) AS VRUNITARIO,
                           DECODE(MEDVAREST.NRMEDVARMEDICAOFATURA, NULL, ITMEDEST.VRITEMCONT, DECODE(MEDVAREST.QTMEDIDAMEDICAO, 0, 0, DECODE(NVL(VAREST.VRPRECOVARIACAO, 0), 0, ITCONT.VRUNITITEMCONT, DECODE(NVL(VARVEND.VRPRECOVARIACAO, 0), 0, ITCONT.VRUNITITEMCONT, ITCONT.VRUNITITEMCONT / VARVEND.VRPRECOVARIACAO * VAREST.VRPRECOVARIACAO)))) AS VRUNITARIOEST,
                           ITCONT.NMITEMCONTRATO,
                           NULL AS IDFORMAFATURA,
                           NULL AS IDALTUSUARIO,
                           NULL AS DSJUSTIFICATIVA,
                           ITCONT.QTMEDIDACONTR,
                           ITMED.VRTOTITEMCONT,
                           NVL(ITMED.VRTOTITEMCONT, 0) - NVL(ITMED.VRITEMCONT, 0) AS VRDESCITEM,
                           MEDVAR.IDMULTIPVARIACAO,
                           MEDVAR.QTMEDIDAMEDICAO,
                           EST.NRMEDICAOFATURAAUX,
                           ITMEDEST.VRTOTITEMCONT AS VRTOTITEMCONTEST,
                           NVL(ITMEDEST.VRTOTITEMCONT, 0) - NVL(ITMEDEST.VRITEMCONT, 0) AS VRDESCITEMEST,
                           MEDVAREST.IDMULTIPVARIACAO AS IDMULTIPVARIACAOEST,
                           MEDVAREST.QTMEDIDAMEDICAO AS QTMEDIDAMEDICAOEST
                      FROM FCT_ITMEDICAOFATURA ITMED
                     INNER JOIN FCT_MEDICAOFATURA MED
                        ON ITMED.NRMEDICAOFATURA = MED.NRMEDICAOFATURA
                     INNER JOIN FCT_CONTRATO CONT
                        ON MED.NRSEQCONTRATO = CONT.NRSEQCONTRATO
                     INNER JOIN FCT_ITEMCONTRATO ITCONT
                        ON MED.NRSEQCONTRATO = ITCONT.NRSEQCONTRATO
                       AND ITMED.CDSERVORCA  = ITCONT.CDSERVORCA
                     INNER JOIN FCT_ITNEGOCIACAOCONTRATO ITNEG
                        ON ITCONT.NRITEMOCONTRATO = ITNEG.NRITEMOCONTRATO
                     INNER JOIN FCT_NEGOCIACAOCONTRATO NEG
                        ON ITNEG.NRNEGOCIACAOCONTRATO = NEG.NRNEGOCIACAOCONTRATO
                      LEFT JOIN FCT_MEDVARMEDICAOFATURA MEDVAR
                        ON MED.NRMEDICAOFATURA = MEDVAR.NRMEDICAOFATURA
                       AND ITCONT.CDSERVORCA   = MEDVAR.CDSERVORCA
                       AND ITCONT.IDELEMENTO   = MEDVAR.IDELEMENTORAIZ
                      LEFT JOIN FCT_VARPRECBASESERVCONT VAR
                        ON MED.NRSEQCONTRATO         = VAR.NRSEQCONTRATO
                       AND ITCONT.CDTPMEDIDASERV     = VAR.CDTPMEDIDASERV
                       AND ITCONT.CDTPMEDIDAVARIAVEL = VAR.CDTPMEDIDAVARIAVEL
                       AND MED.NRORG                 = VAR.NRORG
                       AND MEDVAR.CDSERVORCA         = VAR.CDSERVORCA
                       AND (MEDVAR.QTMEDIDAMEDICAO + MEDVAR.QTFRANQUIA) BETWEEN VAR.QTMEDIDAINIVARIACAO AND VAR.QTMEDIDAFIMVARIACAO
                      LEFT JOIN FCT_VARPRECBASESERVCONT VARVEND
                        ON MED.NRSEQCONTRATO         = VARVEND.NRSEQCONTRATO
                       AND ITCONT.CDTPMEDIDASERV     = VARVEND.CDTPMEDIDASERV
                       AND ITCONT.CDTPMEDIDAVARIAVEL = VARVEND.CDTPMEDIDAVARIAVEL
                       AND MED.NRORG                 = VARVEND.NRORG
                       AND MEDVAR.CDSERVORCA         = VARVEND.CDSERVORCA
                       AND DECODE(NVL(MEDVAR.QTMEDIDAVENDIDA, 0), 0, 1, MEDVAR.QTMEDIDAVENDIDA) BETWEEN VARVEND.QTMEDIDAINIVARIACAO AND VARVEND.QTMEDIDAFIMVARIACAO
                      LEFT JOIN (TABLE(FCT_BUSCA_PRECOMEDICAO(:NRPARCNEGOCIO, :NRORG))) EST
                        ON MED.NRMEDICAOFATURA = EST.NRMEDICAOFATURA
                      LEFT JOIN FCT_ITMEDICAOFATURA ITMEDEST
                        ON EST.NRMEDICAOFATURAAUX = ITMEDEST.NRMEDICAOFATURA
                       AND ITMED.NRITEMOCONTRATO  = ITMEDEST.NRITEMOCONTRATO
                      LEFT JOIN FCT_MEDVARMEDICAOFATURA MEDVAREST
                        ON EST.NRMEDICAOFATURAAUX    = MEDVAREST.NRMEDICAOFATURA
                       AND MEDVAR.CDSERVORCA         = MEDVAREST.CDSERVORCA
                       AND MEDVAR.IDELEMENTORAIZ     = MEDVAREST.IDELEMENTORAIZ
                       AND MEDVAR.CDTPMEDIDAVARIAVEL = MEDVAREST.CDTPMEDIDAVARIAVEL
                      LEFT JOIN FCT_VARPRECBASESERVCONT VAREST
                        ON MED.NRSEQCONTRATO         = VAREST.NRSEQCONTRATO
                       AND ITCONT.CDTPMEDIDASERV     = VAREST.CDTPMEDIDASERV
                       AND ITCONT.CDTPMEDIDAVARIAVEL = VAREST.CDTPMEDIDAVARIAVEL
                       AND MED.NRORG                 = VAREST.NRORG
                       AND MEDVAREST.CDSERVORCA      = VAREST.CDSERVORCA
                       AND (MEDVAREST.QTMEDIDAMEDICAO + MEDVAREST.QTFRANQUIA) BETWEEN VAREST.QTMEDIDAINIVARIACAO AND VAREST.QTMEDIDAFIMVARIACAO
                     WHERE 'M' || MED.NRMEDICAOFATURA = :NRFATURACONT
                )
                ORDER BY IDARVORE
)
                   $filter

SQL;

        $params = array(
            "NRFATURACONT" => $nrfaturacont,
            "NRORG"        => $nrorg,
            "NRPARCNEGOCIO" => $nrparcnegocio
        );
         return InstanceProvider::getEntityManager()->getConnection()->fetchAll($query, $params);

    }

    public function getContratos($nrorg, $filter, $nrparcnegocio, $situacaoFilter = null, $limit, $offset, $orderString, $conditionsSearchQuery){
        $query = <<<SQL
           SELECT  COUNT(1) OVER () TOTAL_LINES_ZHNEXT, C.* FROM (SELECT fct_refeorcacont.idgeradopor,
               fct_contrato.nrseqcontrato,
               fct_contrato.idtpcontrato,
               fct_contrato.nrcontratofct,
               fct_contrato.nrcontratofct
               || ' - '
               || fct_contrato.dsreferenciacont                                AS
               NMCONTRATO,
               fct_contrato.dtiniciocontrato                                   AS
               DTINICONTRATO,
               fct_contrato.dtfimcontrato                                      AS
               DTFINCONTRATO,
               fct_contrato.nrversaocontrato,
               fct_contrato.cdfilialorca,
               filial.nmfilial,
               fct_contrato.nrseqmodcontra,
               fct_modelocontrato.nmmodcontrato,
               fct_contrato.nrparcnegocio,
               parcnegocio.nmprincipalparc,
               fct_contrato.dsreferenciacont,
               fct_contrato.dtiniciocontrato,
               fct_contrato.dtfimcontrato,
               NULL                                                            AS
               NRDIASVIGCONT,
               fct_contrato.nrdiasprazocont,
               fct_contrato.nrdiavenparcfat,
               fct_contrato.cdindfincont,
               fct_contrato.cdtpindfincon,
               fct_contrato.idpervalfincon,
               fct_contrato.dtpadreajcont,
               fct_contrato.dtpadrprorgcont,
               fct_contrato.nrdiasprorgcont,
               fct_contrato.qtpostotrabcont,
               fct_contrato.idorigcontrato,
               fct_contrato.dtrecisaocontr,
               fct_contrato.idsituacaocontrato,
               fct_contrato.cdfilialfatura,
               fct_contrato.dsobservacaocont,
               fct_contrato.nrseqcontratopai,
               fct_contrato.cdseqcontrato,
               fct_contrato.idqtdiascompcon,
               fct_contrato.nrqtdiascompcon,
               fct_contrato.idtpcompetcont,
               fct_contrato.nrdiacompetcont,
               fct_contrato.idtpdtemissnf,
               fct_contrato.nrdiadtemissnf,
               fct_contrato.idtpdtvenc,
               fct_contrato.idtpreajuste,
               fct_contrato.idtpmesreajuste,
               fct_contrato.nrqtdreajuste,
               fct_contrato.idsomafatucont,
               fct_contrato.idtpfatuincomp,
               TO_CHAR(Nvl(fct_contrato.dtinivigencont, fct_contrato.dtiniciocontrato)) AS
               DTINIVIGENCONT,
               TO_CHAR(Nvl(fct_contrato.dtfinvigencont, fct_contrato.dtfimcontrato))    AS
               DTFINVIGENCONT,
               fct_contrato.idbloqsemmedic,
               fct_contrato.idfaturacontr,
               fct_contrato.cdmodpgto,
               modpgto.dsmodpgto,
               fct_contrato.dtinicfatcontr,
               fct_contrato.cdmnemcriacao,
               fct_contrato.cdcentcust,
               centcust.nmcentcust,
               fct_contrato.nrparcinterlocutor,
               Decode(fct_refeorcacont.idgeradopor, 'PROPOSTA',
               fct_orcamento.nrorcamento,
                                                    NULL)                      AS
               NRORCAMENTO,
               fct_contrato.nrorg,
               fct_contrato.idativo,
               fct_contrato.dtinclusao,
               fct_contrato.cdoperinclusao,
               OPINC.nmoperador                                                AS
               NMOPERINCLUSAO,
               fct_contrato.nrorginclusao,
               fct_contrato.dtultatu,
               fct_contrato.cdoperultatu,
               OPATU.nmoperador                                                AS
               NMOPERULTATU,
               fct_contrato.nrorgultatu,
               fct_refeorcacont.nrseqorcamento,
               MODELO.idutilizacomp,
               fct_contrato.qtparcelasfatu,
               fct_contrato.nrdiavencparcelasfatu,
               fct_contrato.cdoperresponsavel,
               OPERRESP.nmoperador                                             AS
               NMOPERRESP,
               TOTCONT.vrtotalcont,
               fct_capaparamfatcon.idtpfatura,
               fct_capaparamfatcon.qtparcelasfatu                              AS
               QTPARCELASFATUNOVO,
               fct_contrato.dsjustifcancreneg,
               fct_orcamento.nrorcamentomodelo,
               fct_refeorcacont.nrtipoorcamento,
               Nvl(fct_tipoorcamento.idutilizavarpreco, 'N')                   AS
               IDUTILIZAVARPRECO,
               ESCOPO.NMTIPOORCAMENTO 
        FROM   fct_contrato
               LEFT JOIN fct_refeorcacont
                      ON fct_contrato.nrseqcontrato = fct_refeorcacont.nrseqcontrato
                         AND fct_contrato.nrorg = fct_refeorcacont.nrorg
               LEFT JOIN fct_orcamento
                      ON fct_refeorcacont.nrseqorcamento = fct_orcamento.nrseqorcamento
                         AND fct_refeorcacont.nrorg = fct_orcamento.nrorg
               LEFT JOIN (SELECT SUM(VRTOTITEMCOMDESC) AS VRTOTALCONT,
                          nrseqcontrato,nrorg
                    FROM FCT_NEGOCIACAOCONTRATO

                   WHERE NRSEQCONTRATO = NRSEQCONTRATO
                   GROUP  BY nrseqcontrato,
                                    nrorg) TOTCONT
                      ON fct_contrato.nrseqcontrato = TOTCONT.nrseqcontrato
                         AND fct_contrato.nrorg = TOTCONT.nrorg
               LEFT JOIN fct_capaparamfatcon
                      ON fct_contrato.nrseqcontrato = fct_capaparamfatcon.nrseqcontrato
                         AND fct_contrato.nrorg = fct_capaparamfatcon.nrorg
               LEFT JOIN operador OPERRESP
                      ON fct_contrato.cdoperresponsavel = OPERRESP.cdoperador
                         AND fct_contrato.nrorg = OPERRESP.nrorg
               LEFT JOIN filial
                      ON fct_contrato.cdfilialorca = filial.cdfilial
                         AND fct_contrato.nrorg = filial.nrorg
               LEFT JOIN fct_modelocontrato
                      ON fct_contrato.nrseqmodcontra = fct_modelocontrato.nrseqmodcontra
                         AND fct_contrato.nrorg = fct_modelocontrato.nrorg
               LEFT JOIN parcnegocio
                      ON fct_contrato.nrparcnegocio = parcnegocio.nrparcnegocio
                         AND fct_contrato.nrorg = parcnegocio.nrorg
               LEFT JOIN centcust
                      ON fct_contrato.cdcentcust = centcust.cdcentcust
                         AND fct_contrato.nrorg = centcust.nrorg
               LEFT JOIN modpgto
                      ON fct_contrato.cdmodpgto = modpgto.cdmodpgto
                         AND fct_contrato.nrorg = modpgto.nrorg
               LEFT JOIN fct_orcamentomodelo MODELO
                      ON fct_orcamento.nrorcamentomodelo = MODELO.nrorcamentomodelo
                         AND fct_orcamento.nrorg = MODELO.nrorg
               LEFT JOIN operador OPINC
                      ON fct_contrato.cdoperinclusao = OPINC.cdoperador
                         AND fct_contrato.nrorg = OPINC.nrorg
               LEFT JOIN operador OPATU
                      ON fct_contrato.cdoperultatu = OPATU.cdoperador
                         AND fct_contrato.nrorg = OPATU.nrorg
               LEFT JOIN fct_tipoorcamento
                      ON fct_refeorcacont.nrtipoorcamento =
                         fct_tipoorcamento.nrtipoorcamento
                         AND fct_refeorcacont.nrorg = fct_tipoorcamento.nrorg
               LEFT JOIN FCT_REFEORCACONT REFE
                    ON fct_contrato.NRSEQCONTRATO = REFE.NRSEQCONTRATO
                  LEFT JOIN FCT_TIPOORCAMENTO ESCOPO
                    ON NVL(fct_contrato.NRTIPOORCAMENTO, REFE.NRTIPOORCAMENTO) = ESCOPO.NRTIPOORCAMENTO
        WHERE  fct_contrato.nrorg = :NRORG
               AND fct_contrato.nrparcnegocio = :NRPARCNEGOCIO
               $situacaoFilter
               $filter
        ORDER  BY dtinclusao DESC) C
        $conditionsSearchQuery
        $orderString

SQL;

        $params = array(
            "NRPARCNEGOCIO" => $nrparcnegocio,
            "NRORG"         => $nrorg
        );
        $query = Utilities::getPaginatedQuery($query, $limit, $offset);
        $result = InstanceProvider::getEntityManager()->getConnection()->fetchAll($query, $params);
        $total = empty($result) ? 0 : $result[0]['TOTAL_LINES_ZHNEXT'];
        $returnNext = [ 'data' => $result, 'pagination' => [ 'limit' => $limit, 'page' => $offset, 'total' => $total]];
        return $returnNext;
    }

    public function getNegociacaoContratoCompleto($nrseqcontrato, $filters){

        $query = <<<SQL
              SELECT * FROM ( SELECT
        NEG.NRNEGOCIACAOCONTRATO,
        NEG.NRSEQCONTRATO,
        NEG.NRTIPOORCAMENTO,
        ESCOPO.NMTIPOORCAMENTO,
        NEG.IDTPFATURA,
        NEG.CDFILIALFATURA,
        FILIAL.NMFILIAL AS NMFILIALFATURA,
        NEG.NRPARCFATURA,
        NEG.CDTIPOOPERFATURA,
        TIPOOPERAC.NMTIPOOPER,
        NEG.CDSERIENF,
        SERIENF.DSSERIE,
        NEG.CDEMPRESA,
        NEG.CDINSCESTA,
        NEG.CDINSCMUNI,
        NEG.VRTOTITEM,
        NEG.VRPERCDESCITEM,
        NEG.VRDESCITEM,
        NEG.VRTOTITEMCOMDESC,
        NEG.IDATIVO, NEG.NRORG,
        NEG.DTINCLUSAO,
        NEG.NRORGINCLUSAO,
        NEG.CDOPERINCLUSAO,
        NEG.DTULTATU,
        NEG.NRORGULTATU,
        NEG.CDOPERULTATU,
        NEG.NRNEGOCIACAOPROPOSTA,
        FCT_BUSCA_DESCRICAO_ESCOPO(NEG.NRTIPOORCAMENTO, NEG.IDTPFATURA, NEG.CDFILIALFATURA, NEG.NRPARCFATURA, NEG.CDTIPOOPERFATURA, NEG
        .CDSERIENF, NEG.CDEMPRESA, NEG.CDINSCESTA, NEG.CDINSCMUNI, NEG.NRORG) AS DSNOMEAGRUPAMENTO,
        NEG.IDTPDESCONTO
    FROM
        FCT_NEGOCIACAOCONTRATO   NEG
        INNER JOIN FCT_TIPOORCAMENTO        ESCOPO ON NEG.NRTIPOORCAMENTO = ESCOPO.NRTIPOORCAMENTO
                                               AND NEG.NRORG = ESCOPO.NRORG
        INNER JOIN FILIAL ON NEG.CDFILIALFATURA = FILIAL.CDFILIAL
                             AND NEG.NRORG = FILIAL.NRORG
        INNER JOIN TIPOOPERAC ON NEG.CDTIPOOPERFATURA = TIPOOPERAC.CDTIPOOPER
                                 AND TIPOOPERAC.IDENTRSAIDOP = 'S'
                                 AND NEG.NRORG = TIPOOPERAC.NRORG
        INNER JOIN SERIENF ON NEG.CDSERIENF = SERIENF.CDSERIE
                              AND NEG.CDEMPRESA = SERIENF.CDEMPRESA
                              AND NEG.CDINSCESTA = SERIENF.CDINSCESTA
                              AND NEG.CDINSCMUNI = SERIENF.CDINSCMUNI
                              AND NEG.NRORG = SERIENF.NRORG
        WHERE NEG.NRSEQCONTRATO = :NRSEQCONTRATO)
        WHERE 1=1
        $filters
SQL;
        $params = array(
            "NRSEQCONTRATO"  => $nrseqcontrato
        );

        return InstanceProvider::getEntityManager()->getConnection()->fetchAll($query, $params);

    }

    public function getCompetenciaNegoCont($filters){

        $query = <<<SQL
        SELECT * FROM (SELECT  NRCOMPETENCIANEGOCONT ,
             NRCOMPETENCIANEGOPROP ,
             NRNEGOCIACAOCONTRATO ,
             NRDIACOMPETINI ,
             NRDIACOMPETFIN ,
             IDMESCOMPETINI ,
             IDMESCOMPETFIN ,
             QTDIASAPURACAO ,
             IDTPCALCVENC ,
             NRDIACALCVENC ,
             IDMESCALCVENC ,
             QTDIASFATUVENC ,
             IDATIVO ,
             NRORG ,
             DTINCLUSAO ,
             NRORGINCLUSAO ,
             CDOPERINCLUSAO ,
             DTULTATU ,
             NRORGULTATU ,
             CDOPERULTATU  FROM FCT_COMPETENCIANEGOCONT)
             WHERE 1=1
             $filters

SQL;
        return InstanceProvider::getEntityManager()->getConnection()->fetchAll($query);

    }

    public function getParcelanegocont($filters){

        $query = <<<SQL
            SELECT NRPARCELANEGOCONT,
            NRNEGOCIACAOCONTRATO,
            QTDIASFATURAMENTO,
            NRDIAVENCIMENTO,
            VRPARCELA,
            NRPARCELANEGOPROP,
            IDATIVO,
            NRORG,
            DTINCLUSAO,
            NRORGINCLUSAO,
            CDOPERINCLUSAO,
            DTULTATU,
            NRORGULTATU,
            CDOPERULTATU
             FROM FCT_PARCELANEGOCONT
             WHERE 1=1
             $filters

SQL;
        return InstanceProvider::getEntityManager()->getConnection()->fetchAll($query);

    }

    public function getDescperiodonegocont_negociacaocontrato($filters){

        $query = <<<SQL
            SELECT * FROM (SELECT
    DES.NRDESCPERIODONEGOCONT,
    DES.NRNEGOCIACAOCONTRATO,
    NEG.VRTOTITEMCOMDESC AS VRTOTNEGCONT,
    DES.VRPERCDESCITEM,
    DES.VRDESCITEM,
    DES.IDTPDESCONTO,
    DES.VRTOTITEMCOMDESC,
    DES.QTMESESDESC,
    DES.DTFINALVALIDADEDESC,
    DES.IDATIVO,
    DES.NRORG,
    DES.DTINCLUSAO,
    DES.NRORGINCLUSAO,
    DES.CDOPERINCLUSAO,
    DES.DTULTATU,
    DES.NRORGULTATU,
    DES.CDOPERULTATU,
    DES.NRDESCPERIODONEGOPROP,
    DES.NRORDEMAPLICADESC
FROM
    FCT_DESCPERIODONEGOCONT   DES
    INNER JOIN FCT_NEGOCIACAOCONTRATO    NEG ON DES.NRNEGOCIACAOCONTRATO = NEG.NRNEGOCIACAOCONTRATO)
    WHERE 1=1
    $filters

SQL;
        return InstanceProvider::getEntityManager()->getConnection()->fetchAll($query);

    }


    public function getItemsOrcamento($nrorg, $idadicitemorc, $nrseqcontrato, $nrseqorcamento){
        $query = <<<SQL
            SELECT NRSEQCONTRATO,
       NRITEMOCONTRATO,
       NRITEMCONTRATOPAI,
       CDPRODSERV,
       CDSERVORCA,
       CDPRODUTO,
       IDELEMENTO,
       NMITEMCONTRATO,
       QTITEMCONTRATO,
       DECODE(QTFILHOS, 0, CDTPMEDIDASERV, NULL) AS CDTPMEDIDASERV,
       DECODE(QTFILHOS, 0, DSTPMEDIDASERV, NULL) AS DSTPMEDIDASERV,
       DECODE(QTFILHOS, 0, QTMEDIDACONTR, NULL) AS QTMEDIDACONTR,
       DECODE(QTFILHOS, 0, VRUNITITEMCONT, NULL) AS VRUNITITEMCONT,
       DECODE(QTFILHOS, 0, VRTOTITEMCONT, NULL) AS VRTOTITEMSEMDESC,
       DECODE(QTFILHOS, 0, VRPERCDESCITEM, NULL) AS VRPERCDESCITEM,
       DECODE(QTFILHOS, 0, VRDESCITEM, NULL) AS VRDESCITEM,
       VRTOTITEMCOMDESC
  FROM (
    SELECT ITCONT.NRSEQCONTRATO,
           ITCONT.NRITEMOCONTRATO,
           ITCONT.NRITEMCONTRATOPAI,
           NVL(ITCONT.CDSERVORCA, ITCONT.CDPRODUTO) AS CDPRODSERV,
           ITCONT.CDSERVORCA,
           ITCONT.CDPRODUTO,
           ITCONT.IDELEMENTO,
           ITCONT.NMITEMCONTRATO,
           ITCONT.QTITEMCONTRATO,
           NVL(ITCONT.CDTPMEDIDAVARIAVEL, ITCONT.CDTPMEDIDASERV) AS CDTPMEDIDASERV,
           MEDIDA.DSTPMEDIDASERV,
           ITCONT.QTMEDIDACONTR,
           ITCONT.VRUNITITEMCONT,
           ITCONT.VRTOTITEMCONT,
           ITNEG.VRTOTITEM,
           NVL(ITNEG.VRPERCDESCITEM, 0) AS VRPERCDESCITEM,
           NVL(ITNEG.VRDESCITEM, 0) AS VRDESCITEM,
           ITNEG.VRTOTITEMCOMDESC,
           (SELECT COUNT(*)
              FROM FCT_ITNEGOCIACAOCONTRATO
             WHERE NRNEGOCIACAOCONTRATO = ITNEG.NRNEGOCIACAOCONTRATO
               AND NRITEMCONTRATOPAI    = ITNEG.NRITEMOCONTRATO
               AND NRORG                = ITNEG.NRORG) AS QTFILHOS,
           ITCONT.NRORG
      FROM FCT_ITEMCONTRATO ITCONT
     INNER JOIN FCT_ITNEGOCIACAOCONTRATO ITNEG
        ON ITCONT.NRITEMOCONTRATO = ITNEG.NRITEMOCONTRATO
      LEFT JOIN FCT_TIPOMEDIDASERV MEDIDA
        ON NVL(ITCONT.CDTPMEDIDAVARIAVEL, ITCONT.CDTPMEDIDASERV) = MEDIDA.CDTPMEDIDASERV
) ITEM
WHERE NRSEQCONTRATO = :NRSEQCONTRATO

SQL;

        $params = array(
            "NRSEQCONTRATO"  => $nrseqcontrato
        );

        return InstanceProvider::getEntityManager()->getConnection()->fetchAll($query, $params);

    }

    public function getElements($nrorg, $idescolhido, $nrseqorcamento, $filter){
        $query = <<<SQL
            SELECT * FROM (SELECT * FROM(SELECT TO_CHAR(COMP.NRCOMPSERVICO)    AS IDARVORE,
       TO_CHAR(COMP.NRCOMPSERVICOPAI) AS IDARVOREPAI,
       COMP.NRSEQORCAMENTO,
       COMP.NRCOMPSERVICO,
       NULL                           AS NRITCOMPSERVICO,
       COMP.NRCOMPSERVICO             AS CDELEMENTO,
       COMP.NMCOMPSERVICO             AS NMELEMENTO,
       -1                             AS IDORDENAELEMENTO,
       TO_CHAR(COMP.NRCOMPSERVICO)    AS IDELEMENTO,
       NULL                           AS IDELEMENTOPAI,
       COMP.NRORG,
       COMP.IDESCOLHIDO,
       COMP.IDCOMPOBRIGATORIA         AS IDSERVOBRIGCOMP,
       'C'                            AS TIPO,
       COMP.IDATIVO
FROM   FCT_COMPSERVORCAMENTO COMP )
UNION ALL

SELECT * FROM (SELECT DISTINCT TO_CHAR(TRAB.NRCOMPSERVICO)
                || '_'
                || TRAB.IDELEMENTO                                AS IDARVORE,
                DECODE(TRAB.IDELEMENTOPAI, NULL, TO_CHAR(TRAB.NRCOMPSERVICO),
                                           TO_CHAR(TRAB.NRCOMPSERVICO)
                                           || '_'
                                           || TRAB.IDELEMENTOPAI) AS IDARVOREPAI
                ,
                TRAB.NRSEQORCAMENTO,
                TRAB.NRCOMPSERVICO,
                TRAB.NRITCOMPSERVICO,
                ELEMENTO.CDSERVORCA                               AS CDELEMENTO,
                ELEMENTO.NMSERVORCA                               AS NMELEMENTO,
                ELEMENTO.IDORDENAELEMENTO,
                TRAB.IDELEMENTO,
                TRAB.IDELEMENTOPAI,
                TRAB.NRORG,
                TRAB.IDESCOLHIDO,
                TRAB.IDSERVOBRIGCOMP,
                'E'                                               AS TIPO,
                'S'                                               AS IDATIVO
FROM   FCT_TRABSERVORCAMENTO TRAB
       INNER JOIN FCT_SERVICOORCA ELEMENTO
               ON TRAB.IDELEMENTO = ELEMENTO.IDELEMENTO
                  AND TRAB.NRORG = ELEMENTO.NRORG
                  ))
                  WHERE 1=1
$filter
SQL;

        $params = array(
            "NRSEQORCAMENTO" => $nrseqorcamento,
            "IDESCOLHIDO"  => $idescolhido,
            "NRORG"         => $nrorg
        );

        return InstanceProvider::getEntityManager()->getConnection()->fetchAll($query, $params);

    }

    public function getFinancialForScore($nrorg, $nrparcnegocio){
     $query = <<<SQL
     SELECT TO_NUMBER(NVL(SUM(EXPIRED), 0)) AS EXPIRED , 
     TO_NUMBER(NVL(SUM(OPENED), 0)) AS OPENED 
     FROM (SELECT
        case when  (DTATUAVENREC < TRUNC(SYSDATE)) AND (IDSTATBREC IN ('A','E')) then VRLIQUIDBOL else 0 END AS EXPIRED,
        case when (DTATUAVENREC >= TRUNC(SYSDATE)) AND (IDSTATBREC IN ('A','E')) then VRLIQUIDBOL else 0 END AS OPENED,
         IDSTATBREC, VRLIQUIDBOL, DTATUAVENREC
             FROM(
               SELECT
               BO.IDSTATBREC,
               ROUND(ROUND(CR.VRATUAREC, 2) + ((BO.VRFINALBREC - BO.VRBOLREC) * (CR.VRATUAREC/(DECODE(BO.VRBOLREC, 0, 1, BO.VRBOLREC)))),2) AS VRLIQUIDBOL,
               CR.DTATUAVENREC
              FROM NOTAFISCAL NF, CONTARECEBER CR, 
               BOLETRECEBER BO, CLIENTE CL,
               EMPRESA E,BAIXARECEBIDA BR ,
                                            (SELECT SUM(VRIMPOSTONF) AS VRRETENCAO, CDFILIAL, NRLANCTONF
                                               FROM IMPOSTONF I, IMPOSTO II
                                              WHERE I.CDIMPOSTO = II.CDIMPOSTO
                                                AND II.IDTRATIMPO = 'R'
                                              GROUP BY CDFILIAL, NRLANCTONF) IM
         WHERE NF.CDCLIENTE = CL.CDCLIENTE
            AND CL.NRPARCNEGOCIO = :NRPARCNEGOCIO
           AND NF.CDFILIAL = CR.CDFILIAL
           AND NF.NRLANCTONF = CR.NRLANCTONF
           AND CR.CDFILIBOLREC = BO.CDFILIAL
           AND CR.NRLANBOLREC = BO.NRLANBOLREC
           AND BO.CDFILIBAIREC = BR.CDFILIAL(+)
           AND BO.NRBAIXAREC  = BR.NRBAIXAREC(+)
           AND IM.CDFILIAL(+) = NF.CDFILIAL
           AND IM.NRLANCTONF(+) = NF.NRLANCTONF
           AND E.CDEMPRESA      = NF.CDEMPRESA
           AND IDSTATBREC <> 'B'
))
SQL;
    $params = array(
            "NRORG" => $nrorg,
            "NRPARCNEGOCIO" => $nrparcnegocio
        );
        return InstanceProvider::getEntityManager()->getConnection()->fetchAll($query, $params);
    }
 public function getAllFinancialForScore(){
     $query = <<<SQL
     SELECT TO_NUMBER(NVL(SUM(EXPIRED), 0)) AS EXPIRED , 
     TO_NUMBER(NVL(SUM(OPENED), 0)) AS OPENED ,NRPARCNEGOCIO
     FROM (SELECT
        case when  (DTATUAVENREC < TRUNC(SYSDATE)) AND (IDSTATBREC IN ('A','E')) then VRLIQUIDBOL else 0 END AS EXPIRED,
        case when (DTATUAVENREC >= TRUNC(SYSDATE)) AND (IDSTATBREC IN ('A','E')) then VRLIQUIDBOL else 0 END AS OPENED,
         IDSTATBREC, VRLIQUIDBOL, DTATUAVENREC,NRPARCNEGOCIO
             FROM(
               SELECT
               BO.IDSTATBREC,CL.NRPARCNEGOCIO,
               ROUND(ROUND(CR.VRATUAREC, 2) + ((BO.VRFINALBREC - BO.VRBOLREC) * (CR.VRATUAREC/(DECODE(BO.VRBOLREC, 0, 1, BO.VRBOLREC)))),2) AS VRLIQUIDBOL,
               CR.DTATUAVENREC
              FROM NOTAFISCAL NF, CONTARECEBER CR, 
               BOLETRECEBER BO, CLIENTE CL,
               EMPRESA E,BAIXARECEBIDA BR ,
                                            (SELECT SUM(VRIMPOSTONF) AS VRRETENCAO, CDFILIAL, NRLANCTONF
                                               FROM IMPOSTONF I, IMPOSTO II
                                              WHERE I.CDIMPOSTO = II.CDIMPOSTO
                                                AND II.IDTRATIMPO = 'R'
                                              GROUP BY CDFILIAL, NRLANCTONF) IM
         WHERE NF.CDCLIENTE = CL.CDCLIENTE
           AND NF.CDFILIAL = CR.CDFILIAL
           AND NF.NRLANCTONF = CR.NRLANCTONF
           AND CR.CDFILIBOLREC = BO.CDFILIAL
           AND CR.NRLANBOLREC = BO.NRLANBOLREC
           AND BO.CDFILIBAIREC = BR.CDFILIAL(+)
           AND BO.NRBAIXAREC  = BR.NRBAIXAREC(+)
           AND IM.CDFILIAL(+) = NF.CDFILIAL
           AND IM.NRLANCTONF(+) = NF.NRLANCTONF
           AND E.CDEMPRESA      = NF.CDEMPRESA
           AND IDSTATBREC <> 'B'
)) 
GROUP BY NRPARCNEGOCIO
SQL;
        return InstanceProvider::getEntityManager()->getConnection()->fetchAll($query);
    }

    public function getContratosForScore($nrorg, $nrparcnegocio){
        $query = <<<SQL
            SELECT TO_NUMBER(NVL(SUM(PENDENTE), 0)) AS PENDING, TO_NUMBER(NVL(SUM(ESTIMADO), 0)) AS ESTIMATED
FROM (SELECT call.*, DECODE(IDSITUACAO, 'ATRASO', VRVENCIMENTO) AS ATRASO, DECODE(IDSITUACAO, 'FATURADA', VRVENCIMENTO) AS FATURADA,
 DECODE(IDSITUACAO, 'PENDENTE', VRVENCIMENTO) AS PENDENTE, DECODE(IDSITUACAO, 'ESTIMADO', VRVENCIMENTO) AS ESTIMADO
            FROM (
                SELECT DISTINCT
                   DECODE(AGRUPCONT.NRMEDICAOFATURA, NULL, 'P'||FAT.NRFATURACONT, DECODE(AGRUPCONT.IDPARCAGRUP, 'S', 'A'||FAT.NRFATURACONT, 'M'||AGRUPCONT.NRMEDICAOFATURA)) AS NRFATURACONT,
                   CASE
                       WHEN CONTREC.IDSTATREC = 'B' THEN 'RECEBIDO'
                       WHEN NF.NRNOTAFISC IS NULL THEN 'PENDENTE'
                       WHEN TRUNC(CONTREC.DTATUAVENREC) < TRUNC(SYSDATE) THEN 'ATRASO'
                       ELSE 'FATURADA'
                   END AS IDSITUACAO,
                   FAT.VRVENCIMENTO
              FROM FCT_FATURACONT FAT
        INNER JOIN FCT_RELACAGRUPCONTFAT AGRUPCONT
                ON FAT.NRFATURACONT = AGRUPCONT.NRFATURACONT
               AND FAT.NRORG        = AGRUPCONT.NRORG
         LEFT JOIN FCT_CONTRATO CONT
                ON AGRUPCONT.NRSEQCONTRATO = CONT.NRSEQCONTRATO
               AND AGRUPCONT.NRORG         = CONT.NRORG
         LEFT JOIN (SELECT APURFAT.NRFATURACONT, LISTAGG(NF.NRLANCTONF, ', ') WITHIN GROUP( ORDER BY NF.NRLANCTONF ) AS NRLANCTONF,
                           NF.CDFILIAL, LISTAGG(NF.NRNOTAFISC, ', ') WITHIN GROUP( ORDER BY NF.NRNOTAFISC ) AS NRNOTAFISC,
                           NF.DTENTRSAID, APURFAT.NRORG, NF.VRNOTAFISC
                      FROM FCT_RELACAPURACAOFATURA APURFAT
                INNER JOIN FCT_APURACAO APU
                        ON APURFAT.NRAPURACAO = APU.NRAPURACAO
                       AND APURFAT.NRORG      = APU.NRORG
                 LEFT JOIN NOTAFISCAL NF
                        ON APU.NRLANCTONF = NF.NRLANCTONF
                       AND APU.CDFILIAL   = NF.CDFILIAL
                  GROUP BY NF.CDFILIAL, APURFAT.NRFATURACONT, NF.DTENTRSAID, APURFAT.NRORG, NF.VRNOTAFISC) NF
                ON FAT.NRFATURACONT = NF.NRFATURACONT
               AND FAT.NRORG = NF.NRORG
         LEFT JOIN CONTARECEBER CONTREC
                ON CONTREC.NRLANCTONF = NF.NRLANCTONF
               AND CONTREC.CDFILIAL   = NF.CDFILIAL
               AND CONTREC.NRORG      = NF.NRORG
             WHERE FAT.NRORG        = :NRORG
               AND FAT.NRPARCFATURA = :NRPARCNEGOCIO
               AND CONT.IDATIVO     = 'S'
               AND FAT.IDSITUACAO IN ('3')

    UNION ALL

    SELECT DISTINCT DECODE(AGRUPCONT.NRMEDICAOFATURA, NULL, 'P'||FAT.NRFATURACONT, DECODE(AGRUPCONT.IDPARCAGRUP, 'S', 'A'||FAT.NRFATURACONT, 'M'||AGRUPCONT.NRMEDICAOFATURA)) AS NRFATURACONT,
                   'PENDENTE' AS IDSITUACAO,
                   FAT.VRVENCIMENTO
              FROM FCT_FATURACONT FAT
        INNER JOIN FCT_RELACAGRUPCONTFAT AGRUPCONT
                ON FAT.NRFATURACONT = AGRUPCONT.NRFATURACONT
               AND FAT.NRORG        = AGRUPCONT.NRORG
         LEFT JOIN FCT_CONTRATO CONT
                ON AGRUPCONT.NRSEQCONTRATO = CONT.NRSEQCONTRATO
               AND AGRUPCONT.NRORG         = CONT.NRORG
         LEFT JOIN (SELECT APURFAT.NRFATURACONT, LISTAGG(NF.NRLANCTONF, ', ') WITHIN GROUP( ORDER BY NF.NRLANCTONF ) AS NRLANCTONF,
                           NF.CDFILIAL, LISTAGG(NF.NRNOTAFISC, ', ') WITHIN GROUP( ORDER BY NF.NRNOTAFISC ) AS NRNOTAFISC,
                           NF.DTENTRSAID, APURFAT.NRORG, NF.VRNOTAFISC
                      FROM FCT_RELACAPURACAOFATURA APURFAT
                INNER JOIN FCT_APURACAO APU
                        ON APURFAT.NRAPURACAO = APU.NRAPURACAO
                       AND APURFAT.NRORG      = APU.NRORG
                 LEFT JOIN NOTAFISCAL NF
                        ON APU.NRLANCTONF = NF.NRLANCTONF
                       AND APU.CDFILIAL   = NF.CDFILIAL
                 GROUP  BY NF.CDFILIAL, APURFAT.NRFATURACONT, NF.DTENTRSAID, APURFAT.NRORG, NF.VRNOTAFISC) NF
                ON FAT.NRFATURACONT = NF.NRFATURACONT
               AND FAT.NRORG = NF.NRORG
             WHERE FAT.NRORG        = :NRORG
               AND FAT.NRPARCFATURA = :NRPARCNEGOCIO
               AND CONT.IDATIVO     = 'S'
               AND FAT.IDSITUACAO IN ('1', '2', '6')

    UNION ALL

        SELECT 'M'||MED.NRMEDICAOFATURA AS NRFATURACONT,
            'ESTIMADO' AS IDSITUACAO,
            MED.PRECOMEDICAO AS VRVENCIMENTO
         FROM TABLE(FCT_BUSCA_PRECOMEDICAO(:NRPARCNEGOCIO, :NRORG)) MED

) call )

WHERE 1 = 1
SQL;
        $params = array(
            "NRORG" => $nrorg,
            "NRPARCNEGOCIO" => $nrparcnegocio
        );
        return InstanceProvider::getEntityManager()->getConnection()->fetchAll($query, $params);

    }

    public function scoreReportGetFinanceiro($nrparcnegocio, $emissaoFilter, $vencFilter, $pagFilter, $dynamicFilter){
                $query = <<<SQL
                   SELECT  * FROM (SELECT VALIDATOR, IDSTATBREC,
       NRPARCNEGOCIO,
       NRINSJUREMPR,
       NMEMPRESA  ,
       DTEMISSAO , 
       NRNOTAFISC,
       CDSERIE ,
       NRINSJURCLIE ,
       NMRAZSOCCLIE ,
       VRPRODUTOS   ,
       VRNOTAFISC   ,
       ROUND(VRRETIDO/QUANT,2) AS "VRRETENCAO",
       VRORIGREC,
       SUM(VRORIGREC) OVER(PARTITION BY CDFILIAL,NRLANCTONF) AS "VRORIGTOTAL",
       VRAJUSTECONTA, 
       VRAJUSTEBOL ,
       VRLIQUIDBOL ,
       SUM(VRLIQUIDBOL) OVER(PARTITION BY CDFILIAL,NRLANCTONF) AS "VRLIQUIDTOTAL",
       NRPARCELAREC,
       DSCONTAREC ,
       DTORIGVENREC ,
       DTATUAVENREC ,
       DTBAIXAREC ,
       STATUS  

FROM(
SELECT BO.IDSTATBREC, CL.NRPARCNEGOCIO, NF.DTEMISSAO, 
       NRNOTAFISC,
       NF.CDSERIE,
       CL.NRINSJURCLIE,
       CL.NMRAZSOCCLIE,
       NF.VRPRODUTOS,
       NF.VRNOTAFISC,
       NVL(IM.VRRETENCAO,0) AS VRRETIDO,
       CR.VRORIGREC ,
      (CR.VRATUAREC - CR.VRORIGREC) AS VRAJUSTECONTA, 
       ROUND(ROUND(CR.VRATUAREC, 2) + ((BO.VRFINALBREC - BO.VRBOLREC) * (CR.VRATUAREC/(DECODE(BO.VRBOLREC, 0, 1, BO.VRBOLREC)))) - (CR.VRATUAREC ),2) AS VRAJUSTEBOL,
       ROUND(ROUND(CR.VRATUAREC, 2) + ((BO.VRFINALBREC - BO.VRBOLREC) * (CR.VRATUAREC/(DECODE(BO.VRBOLREC, 0, 1, BO.VRBOLREC)))),2) AS VRLIQUIDBOL,
       CR.NRPARCELAREC,
       CR.DSCONTAREC,
       CR.DTORIGVENREC,
       CR.DTATUAVENREC,
       BR.DTBAIXAREC,
       DECODE(BO.IDSTATBREC, 'P','PLANEJADO', 'A', 'EM ABERTO', 'E', 'EMITIDO', 'B', 'BAIXADO')  AS STATUS,
       COUNT(*) OVER(PARTITION BY NF.CDFILIAL,NF.NRLANCTONF) AS QUANT,
       E.NMEMPRESA,
       E.NRINSJUREMPR,
       NF.CDFILIAL,
       NF.NRLANCTONF,
       case when  (CR.DTATUAVENREC < TRUNC(SYSDATE)) AND (BO.IDSTATBREC IN ('A','E')) then 'V' when (CR.DTATUAVENREC >= TRUNC(SYSDATE)) AND (BO.IDSTATBREC IN ('A','E')) then 'P' else 'E' END AS VALIDATOR
  FROM NOTAFISCAL NF, CONTARECEBER CR, 
       BOLETRECEBER BO, CLIENTE CL,
       EMPRESA E,BAIXARECEBIDA BR ,
                                    (SELECT SUM(VRIMPOSTONF) AS VRRETENCAO, CDFILIAL, NRLANCTONF
                                       FROM IMPOSTONF I, IMPOSTO II
                                      WHERE I.CDIMPOSTO = II.CDIMPOSTO
                                        AND II.IDTRATIMPO = 'R'
                                      GROUP BY CDFILIAL, NRLANCTONF) IM
 WHERE NF.CDCLIENTE = CL.CDCLIENTE
    AND CL.NRPARCNEGOCIO = :NRPARCNEGOCIO
   AND NF.CDFILIAL = CR.CDFILIAL
   AND NF.NRLANCTONF = CR.NRLANCTONF
   AND CR.CDFILIBOLREC = BO.CDFILIAL
   AND CR.NRLANBOLREC = BO.NRLANBOLREC
   $emissaoFilter
   $vencFilter
   $pagFilter
   AND BO.CDFILIBAIREC = BR.CDFILIAL(+)
   AND BO.NRBAIXAREC  = BR.NRBAIXAREC(+)
   AND IM.CDFILIAL(+) = NF.CDFILIAL
   AND IM.NRLANCTONF(+) = NF.NRLANCTONF
   AND E.CDEMPRESA      = NF.CDEMPRESA
))
    WHERE 1=1
SQL;
        $params = array(
            "NRPARCNEGOCIO" => $nrparcnegocio

        );
        $finalQuery = $this->getFinalQueryNotBase64($query, null, null, null, null, null, $dynamicFilter);
        return $this->executeQueryAndBuildResponseData(InstanceProvider::getEntityManager(), $finalQuery, $params);
        //return $this->createAndExecuteQueryAndBuildResponseData(InstanceProvider::getEntityManager(), $query, $params);

    }

    public function findAllCalls($customQuery, $situationFilters,  $userId,  $startPos = 0, $finalPos = 9999, $orderBy = 'ID ASC', $groupByLabel = 'N')
    {
        $labelDescription = '';
        if($groupByLabel == 'Y'){
            $labelDescription = 'CALL.LABEL_DESCRIPTION,';
        }
        $query = <<<SQL
            SELECT CALL.NMOPERRESP, CALL.ID, CALL.NRORG, CALL.CDCLIENTE, CALL.CDFILIAL, CALL.CALL_RELATIONSHIP, CALL.TEKNISA_ID,
                   CALL.REFERENCE, CALL.CLASSIFICATION, CALL.CLASSIFICATION_NAME, CALL.REPORTED_BY, CALL.IS_ACTIVE,
                   CALL.REPORTER_NAME, CALL.PRODUCT, CALL.CAUSE, CALL.CAUSE_NAME, CALL.PRODUCT_NAME, CALL.CREATED_ORDER,
                   CALL.UPDATED, TO_CHAR(CALL.CREATED_AT, 'DD/MM/YYYY') AS CREATED_AT, CALL.CLOSED, CALL.STATUS,
                   CALL.PLANNED_DATE, CALL.UPDATED_ORDER, TO_CHAR(CALL.UPDATED_AT, 'DD/MM/YYYY') AS UPDATED_AT,
                   CALL.MAIN_TYPE_CALL, CALL.MAIN_TYPE_CALL_DESCRIPTION, CALL.TYPE, CALL.VERSION_DEV,
                   (SELECT RTRIM(XMLAGG(XMLELEMENT(E, LABEL.DESCRIPTION, ',')
                                          .EXTRACT('//text()')
                                          ORDER BY LABEL.DESCRIPTION
                                       ).GETCLOBVAL(), ','
                                ) AS LABEL_DESCRIPTION
                      FROM CP_CALL_LABEL_RELATION LABEL_REL
                      JOIN CP_CALL_LABEL LABEL ON LABEL_REL.LABEL = LABEL.NRCALLLABEL
                     WHERE LABEL_REL.CALL = CALL.ID
                       ) AS LABEL_DESCRIPTION,
                   CALL.NMRAZSOCCLIE, CALL.NMFANTCLIE, CALL.TEKNISA_INTERLOCUTOR_CODE, CALL.PLANNED_VERSION,
                   CALL.PLANNED_VALUE, CALL.RESPONSABLE_DIVISION_CODE, CALL.CUSTOMER_INTERLOCUTOR_CODE,
                   CALL.CUSTOMER_RESPONSABLE_CODE, CALL.CUSTOMER_INTERLOCUTOR, CALL.CALL_PRIORITY, CALL.RESPONSIBLE_OF_THE_PRODUCT,
                   CALL.RESPONSIBLE_OF_THE_CUSTOMER, CALL.TEKNISA_INTERLOCUTOR, CALL.RESPONSABLE_DIVISION,
                   CALL.PRODUCT_TYPE_NAME

              FROM ($customQuery) CALL
         LEFT JOIN CP_CALL_LABEL_RELATION LABEL_REL ON LABEL_REL.CALL = CALL.ID
         LEFT JOIN CP_CALL_LABEL LABEL ON LABEL_REL.LABEL = LABEL.NRCALLLABEL
          GROUP BY CALL.NMOPERRESP, CALL.ID, CALL.NRORG, CALL.CDCLIENTE, CALL.CDFILIAL, CALL.CALL_RELATIONSHIP, CALL.TEKNISA_ID,
                   CALL.REFERENCE, CALL.CLASSIFICATION, CALL.CLASSIFICATION_NAME, CALL.REPORTED_BY, CALL.IS_ACTIVE,
                   CALL.REPORTER_NAME, CALL.PRODUCT, CALL.CAUSE, CALL.CAUSE_NAME, CALL.PRODUCT_NAME, CALL.CREATED_ORDER,
                   CALL.UPDATED, CALL.CREATED_AT, CALL.CLOSED, CALL.STATUS, CALL.PLANNED_DATE, CALL.UPDATED_ORDER,
                   CALL.UPDATED_AT, CALL.MAIN_TYPE_CALL, CALL.MAIN_TYPE_CALL_DESCRIPTION, CALL.TYPE, CALL.NMRAZSOCCLIE,
                   CALL.NMFANTCLIE, CALL.TEKNISA_INTERLOCUTOR_CODE, CALL.PLANNED_VERSION, CALL.PLANNED_VALUE,
                   CALL.RESPONSABLE_DIVISION_CODE, CALL.CUSTOMER_INTERLOCUTOR_CODE, CALL.CUSTOMER_RESPONSABLE_CODE,
                   CALL.CUSTOMER_INTERLOCUTOR, CALL.CALL_PRIORITY, CALL.RESPONSIBLE_OF_THE_PRODUCT, $labelDescription
                   CALL.RESPONSIBLE_OF_THE_CUSTOMER, CALL.TEKNISA_INTERLOCUTOR, CALL.RESPONSABLE_DIVISION, CALL.VERSION_DEV,
                   CALL.PRODUCT_TYPE_NAME
          ORDER BY $orderBy
SQL;


        $query = Utilities::getPaginatedQuery($query,$finalPos,$startPos);
        $data = InstanceProvider::getEntityManager()->getConnection()->fetchAll($query);


        foreach ($data as &$call){
            $callId = explode( '-', $call['TEKNISA_ID']);
            $callType = $callId[0];
            $call['ID'] = $callType . ' - ' . $call['ID'] . ' (' . trim($callId[1]) . ')';
        }
        return $data;
    }

    public function getQueryIntranetCalls($situationFilters, $specialFilters, $situation, $whereFilters, $orgId)
    {
        $gepOpened  = $situationFilters['GEP']['OPENED'];
        $gepWaiting = $situationFilters['GEP']['WAITING'];
        $gepClosed  = $situationFilters['GEP']['CLOSED'];

        $query = <<<SQL
            SELECT * FROM(SELECT  TO_CHAR(ID) AS ID,
                    TO_CHAR(NRORG) AS NRORG,
                    TO_CHAR(NRSOLISERV) AS CALL_RELATIONSHIP,
                    TO_CHAR(CDCLIENTE) AS CDCLIENTE,
                    TO_CHAR(CDFILIAL) AS CDFILIAL,
                    TO_CHAR(REFERENCE) AS REFERENCE,
                    TO_CHAR(CLASSIFICATION) AS CLASSIFICATION,
                    TO_CHAR(CLASSIFICATION_NAME) AS CLASSIFICATION_NAME,
                    TO_CHAR(REPORTED_BY) AS REPORTED_BY,
                    TO_CHAR(IS_ACTIVE) AS IS_ACTIVE,
                    TO_CHAR(REPORTER_NAME) AS REPORTER_NAME,
                    TO_CHAR(PRODUCT) AS PRODUCT,
                    TO_CHAR(TYPE) AS TYPE,
                    LABEL_DESCRIPTION, NRCALLLABEL,
                        CASE TYPE
                        WHEN 'I'
                            THEN 'I - ' || CALL_RELATIONSHIP
                        WHEN 'S'
                            THEN 'S - ' || CALL_RELATIONSHIP
                        ELSE
                            CALL_RELATIONSHIP
                        END AS TEKNISA_ID,
                    TO_CHAR(CAUSE) AS CAUSE,
                    TO_CHAR(CAUSE_NAME) AS CAUSE_NAME,
                    TO_CHAR(PRODUCT_NAME) AS PRODUCT_NAME,
                    TO_CHAR(CREATED_ORDER) AS CREATED_ORDER,
                    TO_CHAR(NVL(UPDATED_AT,UPDATED), 'DD/MM/YYYY') AS UPDATED,
                    CREATED_AT,
                    TO_CHAR(CLOSED) AS CLOSED,
                    TO_CHAR(STATUS) AS STATUS,
                    TO_CHAR(UPDATED_AT, 'YYYYMMDD') AS UPDATED_ORDER,
                    UPDATED_AT,
                    TO_CHAR(DTCOMPROMISS) AS PLANNED_DATE,
                    'P' AS MAIN_TYPE_CALL,
                    'Produto' AS MAIN_TYPE_CALL_DESCRIPTION,
                    TO_CHAR(PRODUCT_RESPONSABLE_CODE) AS PRODUCT_RESPONSABLE_CODE,
                    TO_CHAR(TEKNISA_INTERLOCUTOR_CODE) AS TEKNISA_INTERLOCUTOR_CODE,
                    TO_CHAR(PLANNED_VERSION) AS PLANNED_VERSION,
                    TO_CHAR(PLANNED_VALUE) AS PLANNED_VALUE,
                    TO_CHAR(RESPONSABLE_DIVISION_CODE) AS RESPONSABLE_DIVISION_CODE,
                    TO_CHAR(CUSTOMER_RESPONSABLE_CODE) AS CUSTOMER_RESPONSABLE_CODE,
                    TO_CHAR(CUSTOMER_INTERLOCUTOR_CODE) AS CUSTOMER_INTERLOCUTOR_CODE,
                    TO_CHAR(CUSTOMER_INTERLOCUTOR) AS CUSTOMER_INTERLOCUTOR,
                    TO_CHAR(CALL_PRIORITY) AS CALL_PRIORITY,
                    TO_CHAR(RESPONSIBLE_OF_THE_PRODUCT) AS RESPONSIBLE_OF_THE_PRODUCT,
                    TO_CHAR(RESPONSIBLE_OF_THE_CUSTOMER) AS RESPONSIBLE_OF_THE_CUSTOMER,
                    TO_CHAR(TEKNISA_INTERLOCUTOR) AS TEKNISA_INTERLOCUTOR,
                    TO_CHAR(RESPONSABLE_DIVISION) AS RESPONSABLE_DIVISION,
                    TO_CHAR(NMRAZSOCCLIE) AS NMRAZSOCCLIE,
                    TO_CHAR(NMFANTCLIE) AS NMFANTCLIE,
                    TO_CHAR(null) AS VERSION_DEV,
                    TO_CHAR(CDOPERRESP) AS CDOPERRESP,
                    TO_CHAR(NMOPERRESP) AS NMOPERRESP, TO_CHAR(PRODUCT_TYPE_NAME) AS PRODUCT_TYPE_NAME
                 FROM  (
                    SELECT  SER.NRSOLISERV,C.NRCALL AS ID, NVL(C.NRORG, SER.NRORG) AS NRORG, SER.CDCLIENTE, SER.CDFILIAL,
                            SER.DSREFESOLI AS REFERENCE, C.CLASSIFICATION,
                            SER.CDOPERADOR AS REPORTED_BY, '' AS CAUSE_NAME,
                            SER.IDATIVO AS IS_ACTIVE, OPE.NMOPERADOR AS REPORTER_NAME,
                            SER.CDPRODCOMP AS PRODUCT, NVL(C.TYPE, 'S') AS TYPE,
                            PRO.NMPRODUTO AS PRODUCT_NAME, ASS.NMASSUNTO AS CLASSIFICATION_NAME,
                            TO_CHAR(SER.NRSOLISERV) AS CALL_RELATIONSHIP, C.CAUSE, SER.DTULTATU AS UPDATED, SER.DTCOMPROMISS,
                            TO_CHAR(SER.DTINCLUSAO, 'YYYYMMDD') AS CREATED_ORDER,
                            SER.DTINCLUSAO AS CREATED_AT,
                            C.PRODUCT_RESPONSABLE_CODE,
                            C.TEKNISA_INTERLOCUTOR_CODE,
                            C.PLANNED_VERSION,
                            C.PLANNED_VALUE,
                            C.RESPONSABLE_DIVISION_CODE,
                            C.CUSTOMER_INTERLOCUTOR_CODE,
                            C.CUSTOMER_RESPONSABLE_CODE,
                            INTE.NMINTECLIE AS CUSTOMER_INTERLOCUTOR,
                            PRI.DSPRIORIDADE AS CALL_PRIORITY,
                            RESPROD.NMOPERADOR AS RESPONSIBLE_OF_THE_PRODUCT,
                            RESPCLIE.NMOPERADOR AS RESPONSIBLE_OF_THE_CUSTOMER,
                            TEKINTE.NMOPERADOR AS TEKNISA_INTERLOCUTOR,
                            CLASOPORT.NMCLASSOPORT AS RESPONSABLE_DIVISION,
                            CLI.NMRAZSOCCLIE,
                            CLI.NMFANTCLIE,
                            LABEL.DESCRIPTION AS LABEL_DESCRIPTION,
                            LABEL.NRCALLLABEL,
                            (SELECT MAX(LFT.DTINCLUSAO) FROM LOGFASETRAM LFT WHERE (LFT.NRSOLISERV = SER.NRSOLISERV AND LFT.CDFILIAL = SER.CDFILIAL) )AS UPDATED_AT,
                           CASE WHEN $gepClosed  THEN 'Fechado'
                                WHEN $gepWaiting THEN 'Aguardando ação do cliente'
                                WHEN $gepOpened  THEN 'Em aberto'
                                ELSE 'Em progresso'
                            END AS STATUS,
                           CASE WHEN (SER.CDFASETRAM IN (SELECT CDFATRAMENCE
                                                           FROM PARAMGERAL PARA
                                                          WHERE PARA.NRORG = SER.NRORG))
                                  OR (SER.IDSOLIENCE = 'S')
                                THEN 'Y'
                           ELSE NULL
                            END AS CLOSED,
                            TO_CHAR(CDOPERRESP) AS CDOPERRESP,
                            TO_CHAR(OPER.NMOPERADOR) AS NMOPERRESP, PRT.NMPRODUTO as PRODUCT_TYPE_NAME
                      FROM  SOLISERV SER
                      JOIN  OPERADOR OPE ON OPE.CDOPERADOR = SER.CDOPERADOR
                      JOIN  PRODUTO PRO  ON PRO.CDPRODUTO = SER.CDPRODCOMP
                      JOIN  ASSUNTO ASS  ON ASS.CDASSUNTO = SER.CDASSUNTO
                 LEFT JOIN PRODUTO PRT ON  (PRT.CDPRODUTO = SER.CDPRODGRUP)
                 LEFT JOIN OPERADOR OPER ON SER.CDOPERRESP = OPER.CDOPERADOR
                 LEFT JOIN  CP_CALL C    ON C.CALL_RELATIONSHIP = SER.NRSOLISERV AND C.TYPE = 'S'
                 LEFT JOIN  CLASSIFICATION CLA ON CLA.ID = C.CLASSIFICATION
                 LEFT JOIN INTECLIE INTE ON INTE.CDINTECLIE = C.CUSTOMER_INTERLOCUTOR_CODE AND INTE.CDCLIENTE = SER.CDCLIENTE
                 LEFT JOIN CRM_PRIORIDADE PRI ON PRI.NRPRIORIDADE = C.PRIORITY_CODE
                 LEFT JOIN OPERADOR RESPROD ON RESPROD.CDOPERADOR = C.PRODUCT_RESPONSABLE_CODE
                 LEFT JOIN PARCLIEFAS PARCLIE ON PARCLIE.CDCLIENTE = SER.CDCLIENTE AND IDTPFATUCLIE = '5'
                 LEFT JOIN OPERADOR RESPCLIE ON RESPCLIE.CDOPERADOR = PARCLIE.CDGERENTEIMPCLI
                 LEFT JOIN OPERADOR TEKINTE ON TEKINTE.CDOPERADOR = C.TEKNISA_INTERLOCUTOR_CODE
                 LEFT JOIN CRM_CLASSOPORTUNI CLASOPORT ON CLASOPORT.NRSEQCLASSOPORT = C.RESPONSABLE_DIVISION_CODE
                 LEFT JOIN CLIENTE CLI ON CLI.CDCLIENTE = SER.CDCLIENTE
                 LEFT JOIN CP_CALL_LABEL_RELATION LABEL_REL ON LABEL_REL.CALL = C.NRCALL
                 LEFT JOIN CP_CALL_LABEL LABEL ON LABEL_REL.LABEL = LABEL.NRCALLLABEL
                 LEFT JOIN ORGANIZACAO ORG ON ORG.NRPARCNEGOCIO = CLI.NRPARCNEGOCIO
                     WHERE  ORG.NRORG = $orgId
                            $specialFilters
                            $situation))
                  WHERE 1=1
                        $whereFilters
SQL;
        return $query;
    }

    public function getFaturamentoContrato($filter, $dtinicompetFilter, $dtfincompetFilter, $dtinicompetFilterMed, $dtfincompetFilterMed, $nrorg, $nrparcnegocio, $limit = 500, $offset = 1, $orderString)
    {

        $query =
            <<<SQL
       SELECT *
            FROM (SELECT DISTINCT DECODE(AGRUPCONT.NRMEDICAOFATURA, NULL, 'P', DECODE(AGRUPCONT.IDPARCAGRUP, 'S', 'A', 'M')) AS TIPO, AGRUPCONT.IDPARCAGRUP, TO_CHAR(DSJUSTIFICATIVA) AS DSJUSTIFICATIVA,
                   DECODE(AGRUPCONT.IDPARCAGRUP, 'N', CONT.NRCONTRATOFCT,  AGRUPA.NMAGRUPAMENTO) AS NRCONTRATOFCT,
                   CASE AGRUPCONT.IDPARCAGRUP WHEN 'N'
                        THEN TO_CHAR(CONT.NRSEQCONTRATO)
                        ELSE (SELECT LISTAGG(NRSEQCONTRATO, '_') WITHIN GROUP( ORDER BY NRSEQCONTRATO)
                                FROM FCT_RELACAGRUPCONTFAT
                               WHERE NRFATURACONT = FAT.NRFATURACONT)
                    END AS NRSEQCONTRATO,
                   DECODE(AGRUPCONT.NRMEDICAOFATURA, NULL, 'P'||FAT.NRFATURACONT, DECODE(AGRUPCONT.IDPARCAGRUP, 'S', 'A'||FAT.NRFATURACONT, 'M'||AGRUPCONT.NRMEDICAOFATURA)) AS NRFATURACONT, FAT.NRGRUPOFATURA, FAT.CDFILIALFATURA, FILIFAT.NMFILIAL AS NMFILIALFATURA,
                   FAT.NRPARCFATURA, PARCFAT.NMPRINCIPALPARC AS NMPARCFATURA, FAT.IDTPFATURA,
                   CASE
                       WHEN CONTREC.IDSTATREC = 'B' THEN 'RECEBIDO'
                       WHEN NF.NRNOTAFISC IS NULL THEN 'PENDENTE'
                       WHEN TRUNC(CONTREC.DTATUAVENREC) < TRUNC(SYSDATE) THEN 'ATRASO'
                       ELSE 'FATURADA'
                   END AS IDSITUACAO,
                   FAT.DTINICOMPET, FAT.DTFINCOMPET,
                   FAT.DTLIMITEAPU, DECODE(NF.NRNOTAFISC, NULL, NULL, CONTREC.DTATUAVENREC) AS DTVENCIMENTO, FAT.NRDIASVENCIMENTO, FAT.QTDIASFATUVENC, FAT.VRVENCIMENTO,
                   FAT.VRFATURADO, FAT.VRFALTAFATURAR, FAT.IDFORMAFATURA, FAT.IDALTUSUARIO, FAT.NRAPURACAO, NF.NRLANCTONF,
                   NF.CDFILIAL AS CDFILIALNF, FILINF.NMFILIAL AS NMFILIALNF, NF.NRNOTAFISC, NF.DTENTRSAID, FAT.IDATIVO,
                   FAT.NRORG, FAT.DTINCLUSAO, FAT.NRORGINCLUSAO, FAT.CDOPERINCLUSAO, FAT.DTULTATU, FAT.NRORGULTATU,
                   FAT.CDOPERULTATU,
                   DECODE(AGRUPCONT.IDPARCAGRUP, 'S', AGRUPA.DSOBSAGRUPAMENTO, CONT.DSREFERENCIACONT) DSREFERENCIACONT,
                   NF.VRNOTAFISC,
                   DECODE(NF.NRNOTAFISC, NULL, NULL, CONTREC.VRATUAREC) AS VRATUAREC,
                   ESCOPO.NMTIPOORCAMENTO,
                   ESCOPO.NRTIPOORCAMENTO
              FROM FCT_FATURACONT FAT
        INNER JOIN FCT_RELACAGRUPCONTFAT AGRUPCONT
                ON FAT.NRFATURACONT = AGRUPCONT.NRFATURACONT
               AND FAT.NRORG        = AGRUPCONT.NRORG
         LEFT JOIN FCT_CONTRATO CONT
                ON AGRUPCONT.NRSEQCONTRATO = CONT.NRSEQCONTRATO
               AND AGRUPCONT.NRORG         = CONT.NRORG
         LEFT JOIN FCT_RELACAGRUPAMENTOCONT RELAGRUPCONT
                ON RELAGRUPCONT.NRSEQCONTRATO = CONT.NRSEQCONTRATO
               AND RELAGRUPCONT.NRORG         = CONT.NRORG
         LEFT JOIN FCT_AGRUPAMENTO AGRUPA
                ON AGRUPA.NRAGRUPAMENTO = RELAGRUPCONT.NRAGRUPAMENTO
               AND AGRUPA.NRORG         = RELAGRUPCONT.NRORG
        INNER JOIN FILIAL FILIFAT
                ON FAT.CDFILIALFATURA = FILIFAT.CDFILIAL
               AND FAT.NRORG          = FILIFAT.NRORG
        INNER JOIN PARCNEGOCIO PARCFAT
                ON FAT.NRPARCFATURA = PARCFAT.NRPARCNEGOCIO
               AND FAT.NRORG        = PARCFAT.NRORG
         LEFT JOIN (SELECT APURFAT.NRFATURACONT, LISTAGG(NF.NRLANCTONF, ', ') WITHIN GROUP( ORDER BY NF.NRLANCTONF ) AS NRLANCTONF,
                           NF.CDFILIAL, LISTAGG(NF.NRNOTAFISC, ', ') WITHIN GROUP( ORDER BY NF.NRNOTAFISC ) AS NRNOTAFISC,
                           NF.DTENTRSAID, APURFAT.NRORG, NF.VRNOTAFISC
                      FROM FCT_RELACAPURACAOFATURA APURFAT
                INNER JOIN FCT_APURACAO APU
                        ON APURFAT.NRAPURACAO = APU.NRAPURACAO
                       AND APURFAT.NRORG      = APU.NRORG
                 LEFT JOIN NOTAFISCAL NF
                        ON APU.NRLANCTONF = NF.NRLANCTONF
                       AND APU.CDFILIAL   = NF.CDFILIAL
                  GROUP BY NF.CDFILIAL, APURFAT.NRFATURACONT, NF.DTENTRSAID, APURFAT.NRORG, NF.VRNOTAFISC) NF
                ON FAT.NRFATURACONT = NF.NRFATURACONT
               AND FAT.NRORG = NF.NRORG
         LEFT JOIN CONTARECEBER CONTREC
                ON CONTREC.NRLANCTONF   = NF.NRLANCTONF
               AND CONTREC.CDFILIAL     = NF.CDFILIAL
               AND CONTREC.NRORG        = NF.NRORG
         LEFT JOIN FILIAL FILINF
                ON NF.CDFILIAL = FILINF.CDFILIAL
         LEFT JOIN FCT_REFEORCACONT REFE
                ON CONT.NRSEQCONTRATO = REFE.NRSEQCONTRATO
              LEFT JOIN FCT_TIPOORCAMENTO ESCOPO
                ON NVL(CONT.NRTIPOORCAMENTO, REFE.NRTIPOORCAMENTO) = ESCOPO.NRTIPOORCAMENTO
             WHERE FAT.NRORG        = :NRORG
               AND FAT.NRPARCFATURA = :NRPARCNEGOCIO
               AND CONT.IDATIVO     = 'S'
               AND FAT.IDSITUACAO IN ('3')

               $dtinicompetFilter
               $dtfincompetFilter

    UNION ALL

    SELECT DISTINCT DECODE(AGRUPCONT.NRMEDICAOFATURA, NULL, 'P', DECODE(AGRUPCONT.IDPARCAGRUP, 'S', 'A', 'M')) AS TIPO, AGRUPCONT.IDPARCAGRUP, TO_CHAR(DSJUSTIFICATIVA) AS DSJUSTIFICATIVA,
                    DECODE(AGRUPCONT.IDPARCAGRUP, 'N', CONT.NRCONTRATOFCT, AGRUPA.NMAGRUPAMENTO) AS NRCONTRATOFCT,
                    CASE AGRUPCONT.IDPARCAGRUP WHEN 'N'
                         THEN TO_CHAR(CONT.NRSEQCONTRATO)
                         ELSE (SELECT LISTAGG(NRSEQCONTRATO, '_') WITHIN GROUP( ORDER BY NRSEQCONTRATO)
                                 FROM FCT_RELACAGRUPCONTFAT
                                WHERE NRFATURACONT = FAT.NRFATURACONT)
                     END AS NRSEQCONTRATO,
                   DECODE(AGRUPCONT.NRMEDICAOFATURA, NULL, 'P'||FAT.NRFATURACONT, DECODE(AGRUPCONT.IDPARCAGRUP, 'S', 'A'||FAT.NRFATURACONT, 'M'||AGRUPCONT.NRMEDICAOFATURA)) AS NRFATURACONT, FAT.NRGRUPOFATURA, FAT.CDFILIALFATURA, FILIFAT.NMFILIAL AS NMFILIALFATURA,
                   FAT.NRPARCFATURA, PARCFAT.NMPRINCIPALPARC AS NMPARCFATURA, FAT.IDTPFATURA,
                   'PENDENTE' AS IDSITUACAO,
                   FAT.DTINICOMPET, FAT.DTFINCOMPET,
                   FAT.DTLIMITEAPU, NULL AS DTVENCIMENTO, FAT.NRDIASVENCIMENTO, FAT.QTDIASFATUVENC, FAT.VRVENCIMENTO,
                   FAT.VRFATURADO, FAT.VRFALTAFATURAR, FAT.IDFORMAFATURA, FAT.IDALTUSUARIO, FAT.NRAPURACAO, NF.NRLANCTONF,
                   NF.CDFILIAL AS CDFILIALNF, FILINF.NMFILIAL AS NMFILIALNF, NF.NRNOTAFISC, NF.DTENTRSAID, FAT.IDATIVO,
                   FAT.NRORG, FAT.DTINCLUSAO, FAT.NRORGINCLUSAO, FAT.CDOPERINCLUSAO, FAT.DTULTATU, FAT.NRORGULTATU,
                   FAT.CDOPERULTATU,
                   DECODE(AGRUPCONT.IDPARCAGRUP, 'N', CONT.DSREFERENCIACONT, AGRUPA.DSOBSAGRUPAMENTO) DSREFERENCIACONT,
                   NF.VRNOTAFISC,
                   NULL AS VRATUAREC,
                   ESCOPO.NMTIPOORCAMENTO,
                   ESCOPO.NRTIPOORCAMENTO
              FROM FCT_FATURACONT FAT
        INNER JOIN FCT_RELACAGRUPCONTFAT AGRUPCONT
                ON FAT.NRFATURACONT = AGRUPCONT.NRFATURACONT
               AND FAT.NRORG        = AGRUPCONT.NRORG
         LEFT JOIN FCT_CONTRATO CONT
                ON AGRUPCONT.NRSEQCONTRATO = CONT.NRSEQCONTRATO
               AND AGRUPCONT.NRORG         = CONT.NRORG
         LEFT JOIN FCT_RELACAGRUPAMENTOCONT RELAGRUPCONT
                ON RELAGRUPCONT.NRSEQCONTRATO = CONT.NRSEQCONTRATO
               AND RELAGRUPCONT.NRORG         = CONT.NRORG
         LEFT JOIN FCT_AGRUPAMENTO AGRUPA
                ON AGRUPA.NRAGRUPAMENTO = RELAGRUPCONT.NRAGRUPAMENTO
               AND AGRUPA.NRORG         = RELAGRUPCONT.NRORG
        INNER JOIN FILIAL FILIFAT
                ON FAT.CDFILIALFATURA = FILIFAT.CDFILIAL
               AND FAT.NRORG          = FILIFAT.NRORG
        INNER JOIN PARCNEGOCIO PARCFAT
                ON FAT.NRPARCFATURA = PARCFAT.NRPARCNEGOCIO
               AND FAT.NRORG = PARCFAT.NRORG
         LEFT JOIN (SELECT APURFAT.NRFATURACONT, LISTAGG(NF.NRLANCTONF, ', ') WITHIN GROUP( ORDER BY NF.NRLANCTONF ) AS NRLANCTONF,
                           NF.CDFILIAL, LISTAGG(NF.NRNOTAFISC, ', ') WITHIN GROUP( ORDER BY NF.NRNOTAFISC ) AS NRNOTAFISC,
                           NF.DTENTRSAID, APURFAT.NRORG, NF.VRNOTAFISC
                      FROM FCT_RELACAPURACAOFATURA APURFAT
                INNER JOIN FCT_APURACAO APU
                        ON APURFAT.NRAPURACAO = APU.NRAPURACAO
                       AND APURFAT.NRORG      = APU.NRORG
                 LEFT JOIN NOTAFISCAL NF
                        ON APU.NRLANCTONF = NF.NRLANCTONF
                       AND APU.CDFILIAL   = NF.CDFILIAL
                 GROUP  BY NF.CDFILIAL, APURFAT.NRFATURACONT, NF.DTENTRSAID, APURFAT.NRORG, NF.VRNOTAFISC) NF
                ON FAT.NRFATURACONT = NF.NRFATURACONT
               AND FAT.NRORG = NF.NRORG
         LEFT JOIN FILIAL FILINF
                ON NF.CDFILIAL = FILINF.CDFILIAL
        LEFT JOIN FCT_REFEORCACONT REFE
                ON CONT.NRSEQCONTRATO = REFE.NRSEQCONTRATO
              LEFT JOIN FCT_TIPOORCAMENTO ESCOPO
                ON NVL(CONT.NRTIPOORCAMENTO, REFE.NRTIPOORCAMENTO) = ESCOPO.NRTIPOORCAMENTO
             WHERE FAT.NRORG        = :NRORG
               AND FAT.NRPARCFATURA = :NRPARCNEGOCIO
               AND CONT.IDATIVO     = 'S'
               AND FAT.IDSITUACAO IN ('1', '2', '6')

    UNION ALL

        SELECT 'M' AS TIPO, NULL AS IDPARCAGRUP, NULL AS DSJUSTIFICATIVA, MED.NRCONTRATOFCT, TO_CHAR(MED.NRSEQCONTRATO) AS NRSEQCONTRATO,
             'M'||MED.NRMEDICAOFATURA AS NRFATURACONT, MED.NRGRUPOFATURA, MED.CDFILIALFATURA,  MED.NMFILIALFATURA,
             MED.NRPARCFATURA, MED.NMPARCFATURA, MED.IDTPFATURA, 'ESTIMADO' AS IDSITUACAO,
             MED.DTINICOMPET,MED.DTFINCOMPET,
             MED.DTLIMITEAPU, NULL AS DTVENCIMENTO, MED.NRDIASVENCIMENTO, MED.QTDIASFATUVENC,MED.PRECOMEDICAO AS VRVENCIMENTO,
             0 AS VRFATURADO, MED.PRECOMEDICAO AS VRFALTAFATURAR, NULL AS IDFORMAFATURA, NULL AS IDALTUSUARIO, NULL AS NRAPURACAO, NULL AS NRLANCTONF,
             NULL AS CDFILIALNF, NULL AS NMFILIALNF, NULL AS NRNOTAFISC, NULL AS DTENTRSAID, MED.IDATIVO,
             MED.NRORG, MED.DTINCLUSAO, MED.NRORGINCLUSAO, MED.CDOPERINCLUSAO, MED.DTULTATU, MED.NRORGULTATU,
             MED.CDOPERULTATU,  MED.DSREFERENCIACONT,
             NULL AS VRNOTAFISC,
             NULL AS VRATUAREC,
             ESCOPO.NMTIPOORCAMENTO,
             ESCOPO.NRTIPOORCAMENTO
         FROM TABLE(FCT_BUSCA_PRECOMEDICAO(:NRPARCNEGOCIO, :NRORG)) MED
         INNER JOIN FCT_CONTRATO CONT
               ON MED.NRSEQCONTRATO = CONT.NRSEQCONTRATO
              AND MED.NRORG = CONT.NRORG
          LEFT JOIN FCT_REFEORCACONT REFE
                ON CONT.NRSEQCONTRATO = REFE.NRSEQCONTRATO
              LEFT JOIN FCT_TIPOORCAMENTO ESCOPO
                ON NVL(CONT.NRTIPOORCAMENTO, REFE.NRTIPOORCAMENTO) = ESCOPO.NRTIPOORCAMENTO
         WHERE CONT.IDATIVO = 'S'

         $dtinicompetFilterMed
         $dtfincompetFilterMed
)

WHERE 1 = 1
    $filter
    $orderString

SQL;

        $params = array(
            "NRORG" => $nrorg,
            "NRPARCNEGOCIO" => $nrparcnegocio
        );
        $query = Utilities::getPaginatedQuery($query, $limit, $offset);
        return InstanceProvider::getEntityManager()->getConnection()->fetchAll($query, $params);
    }

    public function getEscopoTIpoOrcamento(){

        $query = <<<SQL
        SELECT * FROM FCT_TIPOORCAMENTO
SQL;
        return $this->createAndExecuteQueryAndBuildResponseData(InstanceProvider::getEntityManager(), $query);
  }

    public function findCallsByType($situationFilters, $nrorg){


        $pmOpened   = implode(',', $situationFilters['PM']['OPENED']);
        $pmWaiting  = implode(',', $situationFilters['PM']['WAITING']);
        $pmClosed   = implode(',', $situationFilters['PM']['CLOSED']);

        $gepOpened  = $situationFilters['GEP']['OPENED'];
        $gepWaiting = $situationFilters['GEP']['WAITING'];
        $gepClosed  = $situationFilters['GEP']['CLOSED'];
        $query = <<<SQL
  SELECT NVL(TO_NUMBER(SUM(AGUARDANDO)), 0) AS WAITING,
                    NVL(TO_NUMBER(SUM(ABERTO)), 0) AS OPENED,
                    NVL(TO_NUMBER(SUM(FECHADO)), 0) AS CLOSED,
                    NVL(TO_NUMBER(SUM(PROGRESSO)), 0) + NVL(TO_NUMBER(SUM(ALL_OPEN)), 0) AS IN_PROGRESS
    FROM (
             SELECT CALL.CDCLIENTE,CALL.IS_ACTIVE,
                   TO_DATE(TO_CHAR(CALL.CREATED_AT, 'DD/MM/YYYY')) AS CREATED_AT, CALL.STATUS,
                   DECODE(CALL.STATUS, 1, 1) AS AGUARDANDO,
                   DECODE(CALL.STATUS, 2, 1) AS ABERTO,
                   DECODE(CALL.STATUS, 3, 1) AS FECHADO,
                   DECODE(CALL.STATUS, 4, 1) AS PROGRESSO, ISSUE_ID, DECODE(CALL.ALL_OPEN, 1, 1) AS ALL_OPEN
              FROM (                    SELECT * FROM(SELECT
                    TO_CHAR(CDCLIENTE) AS CDCLIENTE,ISSUE_ID,
                    TO_CHAR(IS_ACTIVE) AS IS_ACTIVE,
                    CREATED_AT,
                    CASE WHEN STATUS = '1'
                    THEN '1'
                    WHEN STATUS = '2' AND TO_CHAR(CREATED_AT, 'mmyyyy') = TO_CHAR(SYSDATE, 'mmyyyy')
                    THEN '2'
                    WHEN STATUS = '3' AND TO_CHAR(END_DATE, 'mmyyyy') = TO_CHAR(SYSDATE, 'mmyyyy')
                    THEN '3'
                    WHEN STATUS = '4'
                    THEN '4'
                    ELSE '5'
                    END AS STATUS,
                    CASE WHEN STATUS = '2' THEN '1' ELSE '2' END AS ALL_OPEN

                  FROM (
                  SELECT TAS.ID AS ISSUE_ID, TAS.ORGANIZATION AS NRORG, SRE.EXTERNAL_CODE AS CDCLIENTE,

                         TAS.STATUS AS IS_ACTIVE,'I' AS TYPE,
                         TAS.END_DATE,
                         TAS.CREATED_AT,
                          CASE WHEN TS.ID IN($pmWaiting) OR (SELECT NVL(CONTROL,'I') FROM (SELECT CTY.CONTROL
                                                    FROM COMMENTS COM
                                                    LEFT JOIN COMMENT_TYPE CTY ON(COM.COMMENT_TYPE_ID = CTY.ID )
                                                    WHERE COM.TASK = TAS.ID
                                                    ORDER BY COM.ID DESC)
                                                    WHERE ROWNUM = 1 ) = 'Q'
                            THEN '1'
                         WHEN TS.ID IN($pmOpened)
                              THEN '2'
                         WHEN TS.ID IN($pmClosed)
                             THEN '3'
                             ELSE '4'
                         END AS STATUS
                    FROM TASK TAS
                    JOIN TASK_STATUS TS ON TS.ID = TAS.TASK_STATUS
               LEFT JOIN ALLOCATION SA ON (SA.TASK = TAS.ID AND SA.TYPE = 'S')
               LEFT JOIN RESOURCE_T SRE ON (SRE.ID = SA.RESOURCE_T)
                    JOIN PROJECT PRO ON TAS.PROJECT = PRO.ID AND PRO.STATUS = 'A'
                    JOIN ORGANIZACAO ORG ON ORG.NRORG = $nrorg
                    JOIN CLIENTE CLI ON ORG.NRPARCNEGOCIO = CLI.NRPARCNEGOCIO


                   WHERE TAS.IS_ISSUE = 'Y'
                     AND TAS.STATUS NOT IN ('D')
                     AND (SRE.EXTERNAL_CODE IN (CLI.CDCLIENTE))
                         ))
               WHERE 1=1
                      UNION
                      SELECT * FROM(SELECT
                    TO_CHAR(CDCLIENTE) AS CDCLIENTE, null as ISSUE_ID,
                    TO_CHAR(IS_ACTIVE) AS IS_ACTIVE,
                    CREATED_AT,
                    CASE WHEN STATUS = '1'
                    THEN '1'
                    WHEN STATUS = '2' AND TO_CHAR(DTABERSOLI, 'mmyyyy') = TO_CHAR(SYSDATE, 'mmyyyy')
                    THEN '2'
                    WHEN STATUS = '3' AND TO_CHAR(DTENCESOLI, 'mmyyyy') = TO_CHAR(SYSDATE, 'mmyyyy')
                    THEN '3'
                    WHEN STATUS = '4'
                    THEN '4'
                    ELSE '5'
                    END AS STATUS, CASE WHEN STATUS = '2' THEN '1' ELSE '2' END AS ALL_OPEN
                 FROM  (
                    SELECT  SER.NRSOLISERV, SER.CDCLIENTE,SER.DTABERSOLI, SER.DTENCESOLI,
                            SER.IDATIVO AS IS_ACTIVE ,SER.DTCOMPROMISS,
                            SER.DTINCLUSAO AS CREATED_AT,
                           CASE WHEN $gepClosed  THEN '3'
                                WHEN $gepWaiting THEN '1'
                                WHEN $gepOpened  THEN '2'
                                ELSE '4'
                            END AS STATUS
                      FROM  SOLISERV SER
                      JOIN  PRODUTO PRO  ON PRO.CDPRODUTO = SER.CDPRODCOMP
                      JOIN OPERADOR OPE ON  SER.CDOPERRESP = OPE.CDOPERADOR
                      JOIN ORGANIZACAO ORG ON ORG.NRORG = $nrorg
                      JOIN CLIENTE CLI ON ORG.NRPARCNEGOCIO = CLI.NRPARCNEGOCIO

                 WHERE  ( SER.CDCLIENTE IN (CLI.CDCLIENTE))

                         ))
                  WHERE 1=1
                        ) CALL )
SQL;
        $result = InstanceProvider::getEntityManager()->getConnection()->fetchAll($query);
        return count($result)>0 ? $result[0] : array();
    }


    public function getAllSituation($nrorg,$waitingTicket){



        $query = <<<SQL
      SELECT TO_CHAR(TST.ID) AS ID, 'PM' AS PRODUCT,
             CASE WHEN TPR.ID IS NOT NULL THEN 'CLOSED'
                  WHEN TST.CONTROL = 'B' THEN 'OPENED'
                  WHEN TST.CONTROL IN ('H','A') THEN 'WAITING'
                  ELSE 'IN_PROGRESS'
              END AS SITUATION
            FROM TASK_STATUS TST
            LEFT JOIN TASK_PROPERTIES TPR ON(TPR.FINAL_TASK_STATUS = TST.ID)
            WHERE IS_PROJECT = 'N'
            AND TST.ORGANIZATION = $nrorg

            UNION

            SELECT TO_CHAR(NRSEQSITUACAO) AS ID ,'CRM' AS PRODUCT,
            CASE WHEN NRSEQSITUACAO IN (4) THEN 'CLOSED'
                  WHEN NRSEQSITUACAO IN (1) THEN 'OPENED'
                  WHEN NRSEQSITUACAO IN ($waitingTicket) THEN 'WAITING'
                  ELSE 'IN_PROGRESS'
              END AS SITUATION
            FROM CRM_SITUACAO
            WHERE NRORG IN ( $nrorg ,0)
SQL;
        return InstanceProvider::getEntityManager()->getConnection()->fetchAll($query);
    }

}
